$name = 'collapse';
$tot_itt=2;
$off=1000;
$offi=100;
$offd=0

fem def para;r;${name};example          # Declares array dimensions 
fem def coord;r;${name};example         # Defines the coordinate system
fem def base;r;${name}_cubic;example    # Reads in nodal information
fem def node;r;${name}_version;example  # Defines tri-cubic Hermite basis funcs.
fem def elem;r;${name}_version;example

fem update nodes derivative 1 linear;   # Updates the derivatives in all three
fem update nodes derivative 2 linear;   # xi directions
fem update nodes derivative 3 linear;   #

fem export node;${name}_initial as ${name}_initial offset $offi;
fem export elem;${name}_initial as ${name}_initial offset_node $offi offset_elem $offi;

fem def field;r;${name}_version;example      # Reads in field variables
fem def elem;r;${name}_version;example field # Defines connectivity of fld. var.
fem update field from geometry               # Updates field 

fem group faces 1,2,3,4,5 as FFFFF           # Defines face group

fem def data;r;${name};example          # Reads in data information

fem def xi;c closest_face search_start 3 faces FFFFF   
# Projects data onto faces, the search_start N option controls the number
# of faces that will be searched to find the closest. The faces to
# be searched are chosen by measuring the distance from the data point
# to a seed point or points on every face then the closest N are used
# to do an orthogonal projection and the closest one of those is
# selected. It is done this way because it is computationally more
# efficient to measure the distance to a point on the face than it is
# to do an orthogonal projection. For this small example problem it's
# not an issue but for larger meshes it could be.
# The number of faces to include in the search can be specfied using the
# search_start option and number of seed points to use (actually the number
# you specify is the square root of the no of seed points)  
# can be specified using the seed_points option. However using too many 
# seed points can be slower than using a large search_start value. It may
# take a bit of trial and error to figure out the best combination. The
# brute force "can't fail" approach is to make the search value equal
# to the number of faces in the problem then the command will attempt
# an orthogonal projection onto every face and will choose the closest.

#fem def xi;w;${name} closest_face faces FFFFF   # only in group FFFFF.
fem li data error;                              # Writes out xi positions

fem export data;${name}_initial_error error as ${name}_initial_error

for ($fit_itt=1; $fit_itt<=$tot_itt; $fit_itt=$fit_itt+1)
  {
   # Note that the node position and Xi1 derivative are fixed in the ipfit
   # file. This means that the collapsed Xi1 line, connecting nodes 5 and 6
   # does not get fitted. If either of these is unfixed then the positions
   # and Xi1 derivatives for each version are not consistent and the mesh
   # has "holes" in it. Fixing none of the fit variables causes cm to crash.
   fem def fit;r;${name}_${fit_itt};example geometry faces FFFFF
   fem fit
   fem update node fit
   fem update scale_factor normalise
   fem def xi;c closest_face search_start 3 faces FFFFF #old

   system "echo ' ======================================================' "    
   fem li data error
   system "echo ' ITERATION ${fit_itt} DONE' "
   system "echo ' ======================================================' "
  }
fem export data;${name}_fitted_error error as ${name}_fitted_error offset $offd 
fem export nodes;${name}_fitted as ${name}_fitted offset $off;
fem export elem;${name}_fitted as ${name}_fitted offset_node $off offset_elem $off;

