#Example_314 Steady state temperature distribution in a plate (see example_111).
#This example is used to test the convergence of the Laplace or Poisson equation
#The basis function can be checked with either Bilinear or Bicubic Hermite    
# 
fem                               #Set the FEM environment
fem define parameters;r;laplin1;example  #Reads parameters needed to define the plate

fem define coordinates;r;;example #Reads in the coordinates used for the plate
fem define nodes;r;;example       #Reads in the 15 nodes to define the plate
fem define bases;r;;example       #Defines a bilinear basis function
fem define elements;r;;example    #Reads in eight elements from file
fem define wind;c                 #Calculates the graphic window size
fem draw lines                    #Makes the line segments visible
fem draw nodes                    #Makes the node numbers visible
fem define equation;r;;example    #Defines a STATIC analysis of LAPLACE's 
#                                 !equation (STANDARD) using GALERKIN 
#                                 !FINITE ELEMENTS with LINEAR ANALYSIS
fem define material;r;;example    #Define material properties (none)
fem define initial;r;;example     #Defines initial conditions
#                                 !Three sides are held at zero and the forth
#                                 !side has a heat function of Sin(Pi Y/L)
fem define solve;r;;example       #Defines solver options, default all settings
fem list node solution            #Lists the initial solutions
fem sol                           #Solves the boundary value problem
fem list node solution            #Lists the nodal solutions
fem list node flux                #Lists the nodal (heat) fluxes
fem draw field                    #This will draw colour temperature field
fem draw contours label off       #Draws 10 contours step size 0.1 deg
