# Example 339 - Solving 3d non-dimensional Navier Stokes flow in a pipe

fem def para;r;pipe3d;example # Define the array parameters to allow Voronoi mesh use

fem def coord 3,1             # Define 3d rectangular Cartesian coordinates
fem def node;r;pipe3d;example # Define the Delaunay/Voronoi nodes
fem def base;r;pipe3d;example # Define 3d simplex basis functions 
fem def elem;r;pipe3d;example # Define 3d Delaunay elements
fem up dela                   # Update the Delaunay triangulation to ensure Delaunayism
fem def mesh;r;pipe3d;example # Define a Voronoi mesh to be calculated
fem def equa;r;pipe3d;example # Define equation type. This will be a time integration,
                              # Navier Stokes equation, of a general type, solved 
                              # using finite volumes.       
fem def mate;r;pipe3d;example #  Define material. This is unimportant as the equations
                              # solved are non-dimensional, ie only depend on the 
                              # Reynolds number. These parameters are used only for
                              # conversion back to dimensional form. This has not
                              # been implemented yet.
fem def init;r;pipe3d;example # Define initial conditions. At one end of the pipe will
                              # be a specified inlet velocity (Type inlet), while at the
                              # other end will be an outlet boundary condition. All other
                              # Bc's will be a Wall with zero velocity. Be sure to use
                              # duct flow outlet boundary conditions as they are superior
fem def solv;r;pipe3d;example # Define the solution parameters. 
                              # Always use automatic stepping unless stupid.
                              # As the mesh is fixed, you want to use a sparse LU 
                              # solver (only needs to be factorised once). 
                              # Use QUICK advection (best for steady state cases).
                              # The Courant number scales the maximum allowable
                              # time step by a factor of safety, should be between
                              # 0.3 and 0.7.
fem solv                      # Solve to steady state.

