#Example_523  Uniaxial force for 10% elongation on a unit cube

              #This problem is set up the same as in the uniaxial 
              #extension of the unit cube except that a force is
              #applied to certain nodes in the X-direction instead of 
              #a 10% extension.

if (!defined $example) {
    $example = "./";
}
# Drop off the trailing / in the example path
$chopped = chop $example;
if ($chopped ne "/") {
    $example .= $chopped;
}
fem define coordinates;r;uniforce;example #Define 3D rectangular cartesian. 
fem define node;r;;example         #Defines 8 nodes.
fem define base;r;;example	       #Defines 3 basis functions. 
fem define element;r;;example      #Defines 1 element.            
fem def fibr;r;;example
fem def elem;r;;example fibre
fem define window
fem draw lines
fem define equation;r;;example     #Read in equation information.
fem define material;r;;example     #Read in material information.
fem define initial;r;;example      #For the initial conditions, set up the
#                              !  same as in the first uniaxial problem
#                              !  except instead of fixing nodes 2,4,6,8
#                              !  for equation 1 to 0.1, apply a force
#                              !  boundary condition to these nodes of
#                              !  magnitude that will give the same 10% 
#                              !  elongation, ie Cauchy stress*deformed
#                              !  area/# nodes or 4.486*0.9535*0.9535/4
#                              !  =1.0196.
fem define solve;r;;example        #Read in solution information.
fem solve step 1 error 10D-10  #Solve the problem.  Results should be 
#                              !  the same as in the 10% uniaxial 
#                              !  extension problem.
fem draw line deformed dotted
fem list strain at 1 ref       #List strain information.
fem list stress at 1 ref       #List stress information.
