#Example_524  10% uniaxial extension of a unit cube with fibres (0 degrees)
              #The problems in this set investigate the effects of
              #adding fibres in different orientations with respect
              #to the applied extension.
 
fem
fem define coordinates;r;unifib0; #Defines 3D rectangular cartesian.
fem define node;r;unifib0         #Defines 8 nodes.
fem define base;r;unifib0	  #Defines 3 basis functions.
fem define element;r;unifib0      #Defines 1 element.
fem define fibre;r;unifib0        #Define fibre orientations in the 1-2
#                                 !  plane wrt Xi 1 coordinate.  For all 8
#                                 !  nodes with
#                                 !  NO VERSION prompting and 0
#                                 !  DERIVATIVES for the fibre angle,
#                                 !  enter fibre angles as 0 degrees.
fem define element;r;unifib0 fibre  #Define the fibre elements. Enter
#                                 !  angles in DEGREES and define the
#                                 !  basis function for the fibre angle
#                                 !  to be the SAME for each element and
#                                 !  use BASIS 1.
fem define window
fem draw lines
fem draw fibres
fem define equation;r;unifib0     #Read in equation information.
fem define material;r;unifib0	  #Stresses in the constitutive law are
#               !  referred to FIBER/TRANSVERSE coordinates.
#               !  Choose a HYPERELASTIC CONSTITUTIVE LAW for which the
#               !  strain energy function, W, is an EXPONENTIAL function
#               !  of FIBRE/TRANSVERSE STRAINS (Ef,Es,En)that has
#               !  5 CONSTANT PARAMETERS: W=alpha(1)*exp(Q) where
#               !  Q=2*alpha(2)*(Ef+Es+En)+alpha(3)*(Ef^2)+
#               !    alpha(4)*(Es^2+En^2+2*Esn^2)+2*alpha(5)*(Efs^2+Enf^2)
#               !  and the constants alpha(i) are: alpha(1)=1,
#               !  alpha(2)=5, alpha(3)=10, alpha(4)=0, alpha(5)=5.
#
fem define initial;r;unifib0      #Defines initial conditions.
fem define solve;r;unifib0        #Defines solution information.
fem solve step 1 error 1.D-10     #Solve the problem.
fem list initial                  #Note the Lagrange multiplier, p=-2.922
#                                 !  ie. hydrostatic pressure=0.5p=-1.461.
fem draw line deformed dotted
fem list strain at 1 ref     #List strain information wrt reference
#                            !  coordinates at 1st gauss point. Stretch
#                            !  ratios: lamda(1)=1.1, lamda(2)=lamda(3)
#                            !  =0.9535. Lagrangian strains:
#                            !  E11=0.105, E22=E33=-0.04545.
fem list stress at 1 ref     #List stress information wrt reference
#                            !  coordinates at 1st gauss point.  Cauchy
#                            !  stress in the Xi 1 direction, T11=3.567
#                            !  and should be the only nonzero stress
#                            !  component.
#
#                !The strains are the same as in the 10% uniaxial
#                !  extension problem because the material properties
#                !  chosen (1st two constants) were the same.  The
#                !  material, however, is no longer isotropic, but since
#                !  no shearing occurs, the stiffness in the transverse
#                !  direction being different from the fibre direction
#                !  does not affect the strains.  Although the strain
#                !  values are the same, the stress is different because
#                !  the material is anisotropic.  Here, the fibre
#                !  direction is the X-direction because the fibres are
#                !  oriented 0 degrees wrt X-axis.
