#Example_534  Inflation and 10% axial extension of a cylinder with
#             fibres and free theta
 
fem
fem define coordinate;r;cylfib2;example #Defines cylindrical polar coords.
fem define node;r;;example         #Defines nodes.
fem define base;r;;example         #Defines basis functions.
fem define element;r;;example      #Defines elements.
fem define fibre;r;;example        #Defines fibre distribution.
fem define element;r;;example fibre #Defines fibre elements.
fem define window;r;;example       #Defines 2D window coordinates.
fem draw lines                 #Make line segments visible on window.
fem define equation;r;;example     #Defines equation.
fem define material;r;;example     #Defines material information.
fem define initial;r;;example      #Similar to the previous cylinder/fibre
#                              !  problem except that for equation 2
#                              !  (theta-direction), make nodes 2,4 free
#                              !  to move (do not prescribe a
#                              !  displacement).
fem define solve;r;;example        #Defines solution information.
fem solve increment 0.5 error 1.0D-10 #Solve the problem with 50% of
#                              !  the prescribed conditions.
fem solve increment 0.5 error 1.0D-10 #Solve the problem for the last
#                              !  increment.
fem list strain ref            #List strain information wrt reference
#                              !  coordinates.
fem list stress ref            #List stress information wrt reference
#                              !  coordinates.
fem draw lines deformed dotted #Draw deformed mesh on window.
 
              #The presence of fibres in different orientations across
              #  the wall of the cylinder leads to a twisting of the
              #  cylinder (deformed theta coordinates of nodes 2,4 are
              #  now displacing).  Although the amount of q displacement
              #  resulting from the fibre distribution is somewhat
              #  different from the previous problem in which
              #  displacement of nodes 2,4 were prescribed, the strains
              #  and stresses are quite similar, especially at the 3rd
              #  Gauss point near where the experimental strains were
              #  measured and optimized parameters were obtained.
