#Example_5511  Inflation of an isotropic Mooney-Rivlin prolate spheroid 

fem
fem define coordinate;r;prolisot;example #Defines 3 GLOBAL PROLATE SPHEROIDAL
#                              !  coordinates. 
#                              !  Transmural interpolation is in
#                              !  Focus^3.Cosh(Lamda).Sinh^2(Lamda).
fem define node;r;;example         #Focus = 37.5. Reads 4 NODES, 3 COORDS,
#                              !  1 VERSION per node per nj, 0 
#                              !  DERIVATIVES for all coords. Nodal 
#                              !  coordinates, Xj, are (lamda,mu,theta):
#                              !  1=(0.43,0,0);2=(0.43,120,0);
#                              !  3=(0.72,0,0); 4=(0.72,120,0).
fem define base;r;;example         #Defines 3 basis functions: 
#                              !  1) Lagrange/Hermite with 3 Xi coords,
#                              !     Linear Lagrange interpolant and 1
#                              !     Gauss point in Xi1 dirctn (theta-
#                              !     circumferential) but 3 in Xi2 (mu-
#                              !     longitudinal) and Xi3 (lamda-
#                              !     transmural);
#                              !  2) An auxiliary basis with 5 auxiliary
#                              !     element parameters, pressure basis
#                              !     same number of Gauss points as for
#                              !     basis function 1, and polynomial
#                              !     degrees of: 0 for Xi1 and Xi2 for
#                              !     all 5 parameters; 0 in Xi3 for 
#                              !     parameter 1; 1 for parameter 2; 2 
#                              !     for parameter 3; -1 for parameter
#                              !     4 (Xi3=0 face pressure bc); & -2
#                              !     for parameter 5 (Xi3=1 face 
#                              !     pressure bc).
#                              !  3) 2 Xi coords with linear Lagrange
#                              !     interpolant, and 3 Gauss points
#                              !     in Xi1 and Xi2 directions.
fem define element;r;;example      #Defines 1 prolate spheroidal element.
fem define fibr;d
fem define elem;r;;example fibre
fem define window;r;;example       #Defines window dimensions in X,Y,Z
#                              !  directions as (min,max):(-5,5),(-5,5),
#                              !  (-5,5).
fem draw lines                 #Makes line segments visible on window.
fem define equation;r;;example     #Static 3D finite elasticity problem with
#                              !  geometric coords as the dependent 
#                              !  variables. Solution is by Galerkin
#                              !  finite elements in a nonlinear
#                              !  analysis of a nonlinear equation.
#                              !  Incompressible material with basis 1
#                              !  in all elements for dep vars 1,2,3
#                              !  and basis 2 in all elements for dep
#                              !  var 4 (hydrostatic pressure).   
fem define material;r;;example     #Stresses in constitutive law are
#                              !  referred to body coords.  Defines a
#                              !  hyperelastic constitutive law for
#                              !  which the strain energy function, W,
#                              !  is a polynomial function of principal 
#                              !  strain invariants. The Mooney-Rivlin 
#                              !  material law is epressed in terms of
#                              !  I1 and I2 to the maximum power of 1.
#                              !  The 4 constant parameters are 0,2,6,0
#                              !  defining the strain energy function as 
#                              !  W = 2*(I1-3) + 6*(I2-3)
fem define initial;r;;example      #Boundary pressure increments are entered
#                              !  and hydrostatic pressure is matched
#                              !  across boundaries with adjacent Xi3
#                              !  faces. Initial displacements are all
#                              !  zero. For dependent variable 2
#                              !  (mu-dirn) fix all nodes (1..4);
#                              !  Dependent variable 3 (theta-dirn), 
#                              !  fix node 2. No force bcs.
#                              !  Dependent variable 4 (hyd press) fix
#                              !  element 1, parameter 4 (Xi3=0 face
#                              !  inside prolate) with increment 
#                              !  magnitude 2, and parameter 5 (Xi3=1
#                              !  face outside prolate) with increment  
#                              !  magnitude 0. No force bcs.
fem define solve;r;;example        #  Read in solution information.
fem solve increment 0.2 iter 3 #Solve the problem.
fem solve increment 0.3 iter 3 #Incrementing of the ventricular 
#                              !  pressure is neccessary to avoid
fem solve increment 0.5        #  unstable solutions. This depends on
#                              !  the constitutive law and pressure
#                              !  magnitude, as the wall is gradually
#                              !  stiffened.
fem draw lines def dotted      #Draw deformed mesh on window.
fem list strain at 1 ref       #List strain information wrt reference
#                              !  coordinates.
fem list stress at 1 ref       #List stress information wrt reference
#                              !  coordinates.
#                                    
#              !Note that if node 1, rather than node 2, is fixed in the
#              !  theta-direction, unpredictable results will follow 
#              !  because the moment needed to fix a node in this
#              !  direction has no moment arm (on axis).
#
#              !Note that volume is not conserved even with a quadratic
#              !  hydrostatic pressure (I3 not equal to 1).



