# ############################################
# Inflated solution is converged OK!
# ############################################
#
# Save scale factors for the wall elements
fem define base;r;wall_readse    #redefine bases to read in scale factors 
fem define line;w;wall reg WALL  #write out scale factors for wall elements
fem define base;r;wall           #redefine bases to calculate scale factors
#

# Command updated by fixcom.sh on Wed Aug 23 17:49:03 NZT 2000
# Old command: assign variable CAVITY 2
$CAVITY = 2

#
# Set up cavity region geometry
fem define region;r;coupled 
fem define coord;r;cavity region $CAVITY
fem define node;r;cavity region $CAVITY
fem define element;r;cavity region $CAVITY
#
# Set up equations, material properties and initial conditions
# for cavity region
fem define equation;r;coupled region WALL,$CAVITY lock
fem define material;r;cavity_isovol region $CAVITY
fem define initial;r;cavity region $CAVITY
#
# Define cavity-to-wall coupling and solution procedure information
fem define coupling;r;coupled 
fem define solve;r;coupled_lu_nosparse coupled region WALL,$CAVITY
#
# Transfer wall deformation from the inflation problem to 
# geometric dependent variables for the cavity region
fem update solution coupled source_region WALL
#
# Set up the reference state for the cavity region to be the deformed 
# configuration from the inflation problem.  To set up the 
# 'inflated cavity', the x-coord ('in 1' represents the 1st RC coord)
# for the central cavity node (node 6) is set to the average of the 
# x-coords for the adjacent interface nodes (node 2 - this could 
# be a list of nodes)
fem update solution cavity_reference average 6 in 1 node 2 region $CAVITY
#
# Re-read scale factors for the wall elements
fem define base;r;wall_readse    #redefine bases to read in scale factors 
fem define line;r;wall reg WALL  #read in scale factors for wall elements
fem define base;r;wall           #redefine bases to calculate scale factors
#
# List undeformed (pre-inflation) and inflated cavity volumes
fem list element total region $CAVITY
fem list element deformed total region $CAVITY
# ############################################
# cavity volume inflated from 40ml to 69ml.
# ############################################
#
fem define window
fem draw lines rgb=grey region WALL,$CAVITY
#
# Check that the current coupled solution is converged (as expected!)
#fem evaluate residuals wrt geom_params coupled
#fem evaluate reactions coupled
fem solve coupled increment 0.0
#fem define initial;r;profib_enddiast region WALL,CAVITY
#
# Save deformed configurations for end diastole
fem define initial;w;profib_enddiast region WALL,$CAVITY
fem draw;add lines deformed dotted rgb=red region WALL,$CAVITY
#
# ############################################
# inflated state is a converged solution for the coupled problem!
# ############################################
#
# ISOVOLUMIC CONTRACTION
#
# Increment intracell calcium conc and solve for isovolumic contraction
fem define active;r;profib_contract
fem solve coupled increment 0.0 iter 10
#fem define initial;r;profib_endisovolcontr region WALL,CAVITY
#
# Save deformed configurations for end isovolumic contraction
fem define initial;w;profib_endisovolcontr region WALL,$CAVITY
#
fem draw;add lines deformed dotted rgb=blue region WALL,$CAVITY
#
# Check that cavity volume has not changed
fem list element deformed total region $CAVITY
# ############################################
# This contraction phase was indeed isovolumic!
# (cavity volume still 69ml).
# ############################################ 
#
# EJECTION
#
# Decrease cavity 'stiffness parameter' and solve for ejection
fem define material;r;cavity_eject region $CAVITY
fem solve coupled increment 0.0
#fem define initial;r;profib_endeject region WALL,CAVITY
#
# Save deformed configurations for end ejection
fem define initial;w;profib_endeject region WALL,$CAVITY
#
fem draw;add lines deformed dotted rgb=green region WALL,$CAVITY
#
# Determine cavity volume at end-ejection.  
# NOTE: to calc cavity volume, the deformed position of the central
# cavity node must be recalc'ed from the averaged adjacent wall nodes.
# After doing this the current solution is meaningless, ie. best to save
# deformed configurations for both regions before this (as above).
fem update solution cavity_reference average 6 in 1 node 2 region $CAVITY
fem list element deformed total region $CAVITY
# ############################################
# Not a huge ejection fraction (!!!), but neverless a decrease 
# in volume from 69ml to 67ml.
# ############################################
