
# Visualisation of the results for the simulation...

$tend = 200;
$tstep = 5.0;

# Set the directory containing the results
$outputDir = "output-$ENV{'HOSTTYPE'}";
$outputDir = "output";

# Set this to 1 to make a movie
if (! defined $movie) {
    $movie = 0;
}
# Set this to 1 to make a series of images
if (! defined $images) {
    $images = 0;
}

# Read in the undeformed geometry
gfx read node $outputDir."/slab";
gfx read element $outputDir."/slab";
# And the initial deformed geometry
gfx read node $outputDir."/deformed_0";
gfx read element $outputDir."/deformed";

# If making a movie or images use a simple single pane 3D window, otherwise 
# create a four pane, orthographic 3D window
if ($movie) {
    gfx create window 1 double_buffer;
    gfx modify window 1 image scene default light_model default;
    gfx modify window 1 image add_light default;
    gfx modify window 1 layout simple ortho_axes z -y eye_spacing 0.25 width 643 height 550;
    gfx modify window 1 set current_pane 1;
    gfx modify window 1 background colour 0 0 0 texture none;
    gfx modify window 1 view parallel eye_point -17.1444 -31.1444 48.8733 interest_point 16 2 2 up_vector 0.5 0.5 0.707107 view_angle 28.5452 near_clipping_plane 0.923152 far_clipping_plane 329.903 relative_viewport ndc_placement -1 1 2 2 viewport_coordinates 0 0 1 1;
    gfx modify window 1 overlay scene none;
    gfx modify window 1 set transform_tool current_pane 1 std_view_angle 40 normal_lines no_antialias fast_transparency;
} elsif ($images) {
		gfx create window 1 double_buffer;
		gfx modify window 1 image scene default light_model default;
		gfx modify window 1 image add_light default;
		gfx modify window 1 layout simple ortho_axes z -y eye_spacing 0.25 width 467 height 266;
		gfx modify window 1 set current_pane 1;
		gfx modify window 1 background colour 0 0 0 texture none;
		gfx modify window 1 view parallel eye_point 20.9308 -59.2444 -22.8801 interest_point 16 2 2 up_vector -0.140954 -0.382333 0.91321 view_angle 22.8788 near_clipping_plane 0.923152 far_clipping_plane 329.903 relative_viewport ndc_placement -1 1 2 2 viewport_coordinates 0 0 1 1;
		gfx modify window 1 overlay scene none;
		gfx modify window 1 set transform_tool current_pane 1 std_view_angle 40 normal_lines no_antialias fast_transparency;
} else {
    gfx create window 1 double_buffer;
    gfx modify window 1 image scene default light_model default;
    gfx modify window 1 image add_light default;
    gfx modify window 1 layout orthographic ortho_axes z -y eye_spacing 0.25 width 643 height 550;
    gfx modify window 1 set current_pane 1;
    gfx modify window 1 background colour 0 0 0 texture none;
    gfx modify window 1 view parallel eye_point -17.1444 -31.1444 48.8733 interest_point 16 2 2 up_vector 0.5 0.5 0.707107 view_angle 40 near_clipping_plane 0.923152 far_clipping_plane 329.903 relative_viewport ndc_placement -1 1 2 2 viewport_coordinates 0 0 1 1;
    gfx modify window 1 overlay scene none;
    gfx modify window 1 set current_pane 2;
    gfx modify window 1 background colour 0 0 0 texture none;
    gfx modify window 1 view parallel eye_point 16 2 68.2888 interest_point 16 2 2 up_vector 0 1 0 view_angle 40 near_clipping_plane 0.662888 far_clipping_plane 236.894 relative_viewport ndc_placement -1 1 2 2 viewport_coordinates 0 0 1 1;
    gfx modify window 1 overlay scene none;
    gfx modify window 1 set current_pane 3;
    gfx modify window 1 background colour 0 0 0 texture none;
    gfx modify window 1 view parallel eye_point -50.2888 2 2 interest_point 16 2 2 up_vector 6.12323e-17 3.7494e-33 1 view_angle 40 near_clipping_plane 0.662888 far_clipping_plane 236.894 relative_viewport ndc_placement -1 1 2 2 viewport_coordinates 0 0 1 1;
    gfx modify window 1 overlay scene none;
    gfx modify window 1 set current_pane 4;
    gfx modify window 1 background colour 0 0 0 texture none;
    gfx modify window 1 view parallel eye_point 16 -64.2888 2 interest_point 16 2 2 up_vector 0 6.12323e-17 1 view_angle 40 near_clipping_plane 0.662888 far_clipping_plane 236.894 relative_viewport ndc_placement -1 1 2 2 viewport_coordinates 0 0 1 1;
    gfx modify window 1 overlay scene none;
    gfx modify window 1 set transform_tool current_pane 1 std_view_angle 40 normal_lines no_antialias fast_transparency;
}

# Create some graphical materials
gfx create material white diff 1.0 1.0 1.0;
gfx create material black diff 0.0 0.0 0.0;
gfx create material green diff 0.0 1.0 0.0;

##
## Use the deformed coordinates
##
gfx modify g_element tissue general clear circle_discretization 6 default_coordinate deformed element_discretization "4*4*4";

##
## Draw the deformed and undeformed lines
##
gfx set line_width 1;
gfx modify g_element tissue lines coordinate coordinates material white;
gfx modify g_element tissue lines material green;

##
## Set-up and draw the deforming fibres
##
# F = dx/dX
gfx define field F coordinate_system rectangular_cartesian gradient coordinate coordinates field deformed;
# F(transpose)
gfx define field F_transpose coordinate_system rectangular_cartesian transpose source_number_of_rows 3 field F;
# The deforming fibre orientation field
gfx define field fibre_axes coordinate_system rectangular_cartesian fibre_axes coordinate coordinates fibre fibres;
gfx define field fibre_axes2 coordinate_system rectangular_cartesian composite fibre_axes.1 fibre_axes.2 fibre_axes.3 fibre_axes.4 fibre_axes.5 fibre_axes.6 fibre_axes.7 fibre_axes.8 fibre_axes.9;
gfx define field deformed_fibre_axes coordinate_system rectangular_cartesian matrix_multiply number_of_rows 3 fields fibre_axes2 F_transpose;
gfx define field deformed_fibre_axis1 coordinate_system rectangular_cartesian composite deformed_fibre_axes.1 deformed_fibre_axes.2 deformed_fibre_axes.3;
# The element points showing the deforming fibre orientation
gfx modify g_element tissue element_points glyph cylinder general size "0*0*0" centre 0.5,0,0 orientation deformed_fibre_axis1 scale_factors "3*0.15*0.15" use_elements cell_centres discretization "1*1*1" native_discretization NONE select_on material green selected_material default_selected;

##
## Set-up and draw a representation of the principal strains
##
# C = F(transpose) . F
gfx define field C coordinate_system rectangular_cartesian matrix_multiply number_of_rows 3 fields F_transpose F;
# 3D identity matrix
gfx define field identity2 coordinate_system rectangular_cartesian composite 1 0 0 0 1 0 0 0 1;
# E = 0.5 (C - I)
gfx define field E2 coordinate_system rectangular_cartesian add fields C identity2 scale_factors 1 -1;
gfx define field E coordinate_system rectangular_cartesian scale field E2 scale_factors 0.5 0.5 0.5 0.5 0.5 0.5 0.5 0.5 0.5;
# Principal strains
gfx define field principal_strains coordinate_system rectangular_cartesian eigenvalues field E;
gfx define field principal_strain1 coordinate_system rectangular_cartesian composite principal_strains.1;
gfx define field principal_strain2 coordinate_system rectangular_cartesian composite principal_strains.2;
gfx define field principal_strain3 coordinate_system rectangular_cartesian composite principal_strains.3;
# and the corresponding vectors
gfx define field principal_strain_vectors coordinate_system rectangular_cartesian eigenvectors eigenvalues principal_strains;
gfx define field deformed_principal_strain_vectors coordinate_system rectangular_cartesian matrix_multiply number_of_rows 3 fields principal_strain_vectors F_transpose;
gfx define field deformed_principal_strain_vector1 coordinate_system rectangular_cartesian composite deformed_principal_strain_vectors.1 deformed_principal_strain_vectors.2 deformed_principal_strain_vectors.3;
gfx define field deformed_principal_strain_vector2 coordinate_system rectangular_cartesian composite deformed_principal_strain_vectors.4 deformed_principal_strain_vectors.5 deformed_principal_strain_vectors.6;
gfx define field deformed_principal_strain_vector3 coordinate_system rectangular_cartesian composite deformed_principal_strain_vectors.7 deformed_principal_strain_vectors.8 deformed_principal_strain_vectors.9;
gfx define field norm_def_principal_strain_vector1 coordinate_system rectangular_cartesian normalise field deformed_principal_strain_vector1;
gfx define field norm_def_principal_strain_vector2 coordinate_system rectangular_cartesian normalise field deformed_principal_strain_vector2;
gfx define field norm_def_principal_strain_vector3 coordinate_system rectangular_cartesian normalise field deformed_principal_strain_vector3;
# Create a spectrum for the strain
gfx create spectrum strain;
gfx modify spectrum strain clear overwrite_colour;
gfx modify spectrum strain linear reverse range -1 0 extend_below red colour_range 1 1 ambient diffuse component 1;
gfx modify spectrum strain linear reverse range 0 1 extend_above blue colour_range 1 1 ambient diffuse component 1;
gfx modify spectrum strain linear reverse range 0 1 extend_above green colour_range 0.5 0.5 ambient diffuse component 1;
# Add some element points to show the principal strains
gfx modify g_element tissue element_points glyph mirror_cone general size "0*0*0" centre 0,0,0 orientation norm_def_principal_strain_vector1 variable_scale principal_strain1 scale_factors "10*0.4*0.4" use_elements cell_centres discretization "1*1*1" native_discretization NONE select_on material white data principal_strain1 spectrum strain selected_material default_selected;
gfx modify g_element tissue element_points glyph mirror_cone general size "0*0*0" centre 0,0,0 orientation norm_def_principal_strain_vector2 variable_scale principal_strain2 scale_factors "10*0.4*0.4" use_elements cell_centres discretization "1*1*1" native_discretization NONE select_on material white data principal_strain2 spectrum strain selected_material default_selected;
gfx modify g_element tissue element_points glyph mirror_cone general size "0*0*0" centre 0,0,0 orientation norm_def_principal_strain_vector3 variable_scale principal_strain3 scale_factors "10*0.4*0.4" use_elements cell_centres discretization "1*1*1" native_discretization NONE select_on material white data principal_strain3 spectrum strain selected_material default_selected;

# If making a movie, loop through time reading in the deforming 
# solution and writing out the frames. otherwise simply read in the 
# first deformed solution
if ($movie) {
    gfx movie create ${cai}.mv quicktime window 1;
    for ($time=0;$time<=$tend;$time+=$tstep) {
	print "Time = $time\n";
	gfx read node $outputDir."/deformed_$time";
	gfx update window 1;
	gfx movie force_onscreen add_frame;
    }
    gfx movie end;
} elsif ($images) {
    for ($time=0;$time<=$tend;$time+=$tstep) {
				print "Time = $time\n";
				gfx read node $outputDir."/deformed_$time";
				gfx update window 1;
				gfx print file $outputDir."/images/image_$time.rgb" rgb window 1;
		}
} else {
    gfx read node $outputDir."/deformed_0";
}
