# Note : region 1 - solid: a cylinder with finite thickness; region 2 - fluid flow
#        class 1 - Finite elasticity problem ; class 2 - Flow through elastic tube

fem define para;r;cylinder_flow_mech;example
fem reallocate
fem define region;r;cylinder_flow_mech;example              # Defines no. of regions
fem define coordinate;r;cylinder_mech;example reg 1         # Defines coordinates for solid         
fem define node;r;cylinder_mech;example reg 1               # Reads in nodal information                
fem define base;r;cylinder_mech;example reg 1               # Defines basis functions (05)                
fem define element;r;cylinder_mech;example reg 1            # Reads in element information            
fem define fibre;r;cylinder_mech;example reg 1              # Reads in fibre information for solid  
fem define element;r;cylinder_mech;example fib reg 1        # Defines fibre interpolation          
fem define equation;r;cylinder_mech;example reg 1 class 1   # Defines equations for solid 
fem define material;r;cylinder_mech;example reg 1 class 1   # Reads in mech properties of solid   
fem define initial;r;cylinder_mech;example reg 1 class 1    # Defines initial & boundary conds.        
fem define solve;r;cylinder_mech;example reg 1 class 1      # Defines solution parameters     

fem define coordinate;r;cylinder_flow;example reg 2         # Defines coordinates for fluid flow        
fem define node;r;cylinder_flow;example reg 2               # Reads in nodal information                
fem define;add base;r;cylinder_flow;example                 # Defines basis functions (01)               
fem define element;r;cylinder_flow;example reg 2            # Reads in element information           

fem define xi;r;cylinder_flow;example node of 2 in 1        # Reads in xi positions of reg 2 wrt reg 1
fem update mesh position of 2 in 1 undeform                 # Updates relative positions

fem define field;r;cylinder_flow;example reg 2              # Reads in field information 
fem define element;r;cylinder_flow;example field reg 2      # Defines field interpolation       
fem define grid;r;cylinder_flow;example coronary reg 2      # Reads in spatial discretisation    
fem update grid geometry reg 2                              # Updates grid point coordinates 
fem define equation;r;cylinder_flow;example reg 2 class 2   # Defines equations for fluid flow  
fem define material;r;cylinder_flow;example reg 2 class 2   # Reads in phy. & mech. properties      
fem update material field material 4 no_field 1 reg 2 class 2
#                                                           # Updates unstressed radii
fem define time;r;cylinder_flow;example                     # Defines boundary conditions   
fem define initial;r;cylinder_flow;example reg 2 class 2    # Defines initial conditions                   
fem define solve;r;cylinder_flow;example reg 2 class 2      # Defines solution parameters                  

fem define coup;r;cylinder_flow_mech;example                # Defines solid & fluid mech. coupling                                     
$time_initial=0.000;
$time_final=0.005;
$time_step=0.0001;   
$write_out_period=0.0005;

fem export nodes;solid${time_initial} field as solid offset 500 reg 1 class 1
fem export elements;solid field as solid offset_elem 500 offset_node 500 reg 1 class 1 
fem export grid;fluid as flow offset_elem 0 offset_node 0 elastic_tube reg 2 class 2
fem export points;fluid${time_initial} grid as flow offset 0 reg 2 class 2

for ($time=$time_initial;$time<$time_final;$time=$time+$write_out_period)      
{
$w_time=$time+$write_out_period;
fem solve restart to $write_out_period delta_t $time_step reg 1,2 class 1,2;
fem update geometry from solution reg 1;
fem export nodes;solid${w_time} field as solid offset 500 reg 1 class 1;
fem update nodes derivative 1 linear reg 2 
fem update mesh position of 2 in 1 undeform
fem update grid geometry reg 2
fem export points;fluid${w_time} grid as flow offset 0 reg 2 class 2
}


