${lobe} = 'left_lower'
${off}=3000
${offt}=5500
${offd}=10500
${off_data}=0

fem def para;r;all_lobe;example
fem def region;r;all_lobe;example

fem def coord;r;all_host;example reg 1          # Defines coords for host

fem def base;r;all_lobe_cubic;example reg 1,2   # Defines bases for host & slave

##################### HOST MESH ##################### 

fem def node;r;${lobe}_host;example reg 1       # Reads in hostmesh nodes
fem def elem;r;${lobe}_host;example reg 1       # Reads in hostmesh elems.

fem export node;${lobe}_host as ${lobe}_host reg 1
fem export elem;${lobe}_host as ${lobe}_host reg 1

################### HOST MESH ######################

################### SLAVE MESH ##################### 

fem def coord;r;all_slave;example reg 2        # Defines coords for slave

fem def node;r;${lobe}_fitted;example reg 2
fem def elem;r;${lobe}_fitted;example reg 2

fem export node;${lobe}_fitted as ${lobe}_fitted offset $off reg 2
fem export elem;${lobe}_fitted as ${lobe}_fitted offset_node $off offset_elem $off reg 2

#fem def xi;c nodes contain of 2 in 1 loose_tolerance # Calculates slave nodal posns wrt host
#fem def xi;w;${lobe} nodes contain of 2 in 1         # Writes out slave nodal posns wrt host

################### SLAVE MESH #################### 

############# HOST MESH TRANSFORMATION ############

fem update field from geometry reg 1

#fem def data;r;${lobe}_landmark;example reg 1  # Reads in landmark data coords   
#fem def xi;c contain reg 1                     # Calculates xi posns of landmark data wrt host     
#fem def xi;w;${lobe}_landmark reg 1            # Writes out landmark xi coords.

fem def data;r;${lobe}_target;example reg 1     # Reads in target data coords       
fem def xi;r;${lobe}_landmark;example reg 1     # Reads in landmark xi coords

fem list data error reg 1     

fem def fit;r;${lobe};example geometry reg 1    # Defines fit parameters for host
fem fit reg 1

############ HOST MESH TRANSFORMATION ############

############### SLAVE MESH UPDATE ################

fem def xi;r;${lobe};example nodes contain of 2 in 1  # Reads in slave xi coord wrt host
fem update mesh position fit of 2 in 1                # Updates slave nodal parameters wrt deformed host
fem update scale_factor normalise reg 2

fem export node;${lobe}_fitted_transformed as ${lobe}_fitted_transformed offset $offt reg 2
fem export elem;${lobe}_fitted_transformed as ${lobe}_fitted_transformed offset_node $offt offset_elem $offt reg 2

fem def node;w;${lobe}_fitted_transformed
fem def elem;w;${lobe}_fitted_transformed

################# SLAVE MESH UPDATE ##############

################ HOST MESH UPDATE ################

fem update node fit reg 1          # Updates deformed host
fem list data error reg 1

fem export node;${lobe}_deformed_host as ${lobe}_deformed_host offset $offd reg 1
fem export elem;${lobe}_deformed_host as ${lobe}_deformed_host offset_node $offd offset_elem $offd reg 1

################ HOST MESH UPDATE ################


