# Example b131 - HMT
#
# Solves the HMT model for a single cell, with a step change in
# length defined by a time varying boundary condtion set by using
# a time variable.

fem define parameters;r;hmt;example

fem define node;d
fem define base;d
fem define element;d
fem define grid;d
fem update grid geom
fem update grid metric

fem define equation;r;hmt;example

fem define cell;r;hmt;example
fem define material;r;hmt;example cell
# Need to define the material conductivities even though they are not 
# really used
fem define material;r;hmt;example
fem update grid material

# read in the time variable describing the step length change
fem define time;r;step;example

# assign the time variable to use for the time varying boundary 
# condition
fem define initial;r;step;example

fem define solve;r;hmt;example

fem solve to 0

fem open history;hmt write variables yqs niqslist 1,2,3,4,5,6,7 binary


for $time ( 0..999 ) 
{
#  Solve for the current time
fem solve restart to $time

#  Write the membrane potential to the history file
fem write history time $time variables yqs binary
}

# Close the history file
fem close history binary

# Write out signal files for all the state variables.

# First as individual signal files
for $UNIT ( 1..7 ) 
{
fem evaluate electrode;hmt_$UNIT history hmt from grid yqs iy $UNIT binary
fem define export;r;hmt;example
fem export signal;hmt_$UNIT electrode signal "hmt_$UNIT"
}

# Then with all variables in one signal file
fem evaluate electrode;hmt_all history hmt from grid yqs iy 1..7 binary
fem define export;r;hmt_all;example
fem export signal;hmt_all electrode signal hmt_all

