#Example b142 - Coupled Noble 98 - HMT

# Set the signals we want to export - if you change these, need to
# update the ipexpo file.
# 	Vm = 1			Cai = 4
# 	CaTROP = 9		z = 26
# 	ExtensionRatio = 27	Tension = 28
# 	IsometricTension = 29


# Command updated by fixcom.sh on Wed Aug 23 17:49:43 NZT 2000
# Old command: assign variable SIGNALS 1,4,9,26,27,28,29
$SIGNALS = "1,4,9,26,27,28,29"


# Define the problem size
fem def para;r;n98_hmt;example

# Create a single node and element
fem def no;d
fem def base;d
fem def elem;d
# Create the single cell we want to use
fem def grid;d
fem update grid geom
fem update grid metric

# Define the equations we want to solve
fem def equa;r;n98_hmt;example

# Define the cellular material parameters
fem def cell;r;n98_hmt;example
fem def mate;r;n98_hmt;example cell
fem def mate;r;n98_hmt;example
fem update grid material

# Define a single step change
fem def time;r;step;example
# and set it to describe the extension ratio variable
fem def init;r;n98_hmt;example

# Define an explict, adaptive Adams-Moulton integration
fem def solv;r;n98_hmt;example

# Initialise the solve
fem solve to 0

# Create the history file to store the signals we want to export
fem open history;test write variables yqs niqslist $SIGNALS binary

# Loop through time (500 ms)

# Command updated by fixcom.sh on Wed Aug 23 17:49:43 NZT 2000
# Old command: DO TIME = 0..499
for $TIME ( 0..499 ) 
{


#  Solve for the current time
  fem solve restart to $TIME

#  Write the signals to the history file
  fem write history time $TIME variables yqs binary


# Command updated by fixcom.sh on Wed Aug 23 17:49:43 NZT 2000
# Old command: ENDDO
}


#  Close the history file
fem close history binary

# Generate a UnEMAP signal file
fem evaluate electrode;test history test from grid yqs iy $SIGNALS binary
fem define export;r;n98_hmt;example
fem export signal;test electrode signal test

# Tidy-up

# Command updated by fixcom.sh on Wed Aug 23 17:49:43 NZT 2000
# Old command: deassign variable SIGNALS
  






