#Example_b2112 Optimisation of conductivities from 2D mapping study
#
#  See Description.html for further explanation.

fem de param;r;example_b2;example           #Parameter settings


fem define bases;r;2d9x9;example 		#9x9 grid pt collocation basis
fem define node;r;peng-small;example 	#13x16 element mesh (26mmx32mm)
fem define elem;r;peng-small;example 	#13x16 element mesh (26mmx32mm)
fem define fibre;d  			#Assumed zero everywhere
fem define elem;d fibre
fem define grid;r;9x9;example 			#creates 13545 grid pts
fem update grid geom
fem update grid metric
fem define equation;r;cubic;example lock 	#Cubic activation model

# Command updated by fixcom.sh on Wed Aug 23 17:49:48 NZT 2000
# Old command: fem define data;r;peng-new-small;example electrode file_format activation
fem define data;r;peng-new-small;example electrode file_format activation

#					!  reads activation times at
#					!  data points
fem define data;c grid 			#Computes closest grid pt to 
#					!  each data pt
fem define material;r;cubic;example 	#Sets up initial mode parameters
fem define cell;r;cubic;example 	#Sets up initial mode parameters
fem update grid material 		#Computes grid pt conductivities
fem define opti;r;peng;example lock 	#Reads optimisation parameters
fem define initial;r;peng-small;example 	#Stimulus pts are at l.hand edge
fem define solve;r;peng4;example lock 	#Solution parameters
#Commented so example can run nightly.
#opt 					!Optimise conductivities

# ! Now write the computed conductivities to a file called:
# ! cubic-solve.ipmate before running the rest of the
# ! example.

fem define material;r;cubic-solve;example 	#Read optimised conductivities
fem update grid material 		#Update grid pt info
fem define initial;r;peng-small;example 	#Use same stimulus
fem define solve;r;peng4;example lock 	#And same solution parameters
#fem solve 				!Solve the activation
#fem update gauss activation 		!Store activation time at gauss
#					!  pts for drawing field
#fem define window;c 			!Open output window
#fem draw field gauss 1 zmin=0 zmax=70 	!Draw computed activation field
#fem draw data rgb=computed 		!Overlay exptl activation times
