$output = "output";

gfx read node $output/3dcube;
gfx read elem $output/3dcube;
gfx read elem $output/potential_0;

#Window Commands
#===============
gfx create window 1 double_buffer;
gfx modify window 1 image scene default light_model default;
gfx modify window 1 image add_light default;
gfx modify window 1 layout simple ortho_axes z -y eye_spacing 0.25 width 469 height 490;
gfx modify window 1 set current_pane 1;
gfx modify window 1 background colour 0 0 0 texture none;
gfx modify window 1 view perspective eye_point 5.65818 -9.57936 9.23 interest_point 2 2 2 up_vector -0.120812 0.498005 0.858718 view_angle 40 near_clipping_plane 0.141328 far_clipping_plane 50.5059 relative_viewport ndc_placement -1 1 2 2 viewport_coordinates 0 0 1 1;
gfx modify window 1 overlay scene none;
gfx modify window 1 set transform_tool current_pane 1 std_view_angle 40 normal_lines no_antialias fast_transparency;

gfx set visibility axes off;

#Material Commands
#=================
gfx create material default ambient 1 1 1 diffuse 1 1 1 emission 0 0 0 specular 0 0 0 alpha 1 shininess 0;
gfx create material isosurface ambient 0.5 0.51 1 diffuse 0.5 0.5 1 emission 0.1 0.1 0.1 specular 0.1 0.1 0.1 alpha 1 shininess 0.5;

#Spectrum Commands
#=================
gfx modify spectrum default clear overwrite_colour;
gfx modify spectrum default linear reverse range -85.004 14.567 extend_above extend_below rainbow colour_range 0 1 ambient diffuse;
## Create an appropriate spectrum
## Total Min. = -90, Total Max. =  50
gfx create spectrum potential log exaggeration 3 right reverse range -90 50 extend_above extend_below rainbow colour_range 0 1 ambient diffuse ;

#Drawing Commands
#================
gfx modify g_element cube general clear circle_discretization 6 default_coordinate default_coordinate element_discretization "12*12*12" native_discretization potential;
gfx modify g_element cube iso_surfaces iso_scalar potential iso_value 0 use_elements select_on material isosurface selected_material default_selected render_shaded;
gfx modify g_element cube element_points glyph diamond general size "0.1*0.1*0.1" centre 0,0,0 use_elements cell_corners discretization "1*1*1" native_discretization potential select_on material default data potential spectrum potential selected_material default_selected;
gfx modify g_element cube cylinders constant_radius 0.05 select_on material default selected_material default_selected;
gfx modify g_element cube node_points glyph sphere general size "0.1*0.1*0.1" centre 0,0,0 select_on material default selected_material default_selected;



#Read in next time steps
#=======================

gfx update window 1;

gfx movie create $output/movie.mv quicktime window 1;
for $time (0..500) {
		print "Time = $time\n";
		gfx read element $output/potential_$time;
		gfx update window 1;
		gfx movie add_frame;
}
gfx movie end;
