#--------------
#Assign regions
#--------------

# Command updated by fixcom.sh on Wed Aug 23 17:49:58 NZT 2000
# Old command: ASSIGN variable MESH2D 1
$MESH2D = 1


# Command updated by fixcom.sh on Wed Aug 23 17:49:58 NZT 2000
# Old command: ASSIGN variable TREE1D 2
$TREE1D = 2

 
fem define para;r;branch;example

 
#--------------------------------------------
#Define two regions, one for the tree and one
#  for the host mesh.
#--------------------------------------------
fem define regi;r;branch;example
 
#---------------------------------------------
#Define a 1d basis for the tree and a 2d basis
#  for the host mesh.
#---------------------------------------------
fem define base;r;branch;example
 
#-------------------------------------
#Define the host mesh in region MESH2D
#-------------------------------------
fem define node;r;square;example reg $MESH2D
fem define elem;r;square;example reg $MESH2D
fem define fibr;d reg $MESH2D
fem define elem;r;square;example fibre reg $MESH2D
 
#-------------------------------------
#Define the host mesh in region MESH2D
#-------------------------------------
fem define node;r;branch;example reg $TREE1D
fem define elem;r;branch;example reg $TREE1D
 
#-----------------------------------------------
#Set up a finite difference grid in both regions
#-----------------------------------------------
fem define grid;r;1and2d;example reg $MESH2D,$TREE1D
fem update grid geometry reg $MESH2D,$TREE1D
fem update grid metric reg $MESH2D,$TREE1D
fem group grid external as boundary1 reg $MESH2D
fem group grid external as boundary2 reg $TREE1D
 
#-----------------------------------
#Set up equations in the two regions
#-----------------------------------
fem define equa;r;square;example reg $MESH2D,$TREE1D
 
#----------------------------------------------
#Define material parameters for the two regions
#----------------------------------------------
fem define mate;r;square;example reg $MESH2D
fem define cell;r;square;example reg $MESH2D
fem define mate;r;branch;example reg $TREE1D
fem define cell;r;branch;example reg $TREE1D
fem update grid material reg $MESH2D
fem update grid material reg $TREE1D
 
#--------------------------------------
#Define initial and boundary conditions
#--------------------------------------
fem define init;r;square;example reg $MESH2D
fem define init;r;branch;example reg $TREE1D
 
#-------------------------------
#Define coupling between regions
#-------------------------------
fem define coup;c tree_region $TREE1D tissue_region $MESH2D
 
#--------------------------
#Define solution parameters
#--------------------------
fem define solv;r;square;example reg $MESH2D,$TREE1D

fem export node;tissue as tissue reg $MESH2D
fem export elem;tissue as tissue reg $MESH2D
fem export node;tree as tree reg $TREE1D
fem export elem;tree as tree reg $TREE1D
 
#-----
#Solve
#-----
fem solve to 0 reg $MESH2D,$TREE1D
fem define wind;c
 

# Command updated by fixcom.sh on Wed Aug 23 17:49:58 NZT 2000
# Old command: DO UNIT=0..9
for $UNIT ( 0..9 ) 
{


# Command updated by fixcom.sh on Wed Aug 23 17:49:58 NZT 2000
# Old command: DO DEC=0,5
for $DEC ( 0,5 ) 
{


# Command updated by fixcom.sh on Wed Aug 23 17:49:58 NZT 2000
# Old command: fem solve restart to $UNIT//.//$DEC reg $MESH2D,$TREE1D
fem solve restart to "${UNIT}.$DEC" reg $MESH2D,$TREE1D

fem update grid solution
fem draw grid values zmin=-120 zmax=20 noscale reg $MESH2D
fem draw field grid 1 zmin=-120 zmax=20 noscale reg $TREE1D
refresh graphics

# Command updated by fixcom.sh on Wed Aug 23 17:49:58 NZT 2000
# Old command: fem export elem;tissue_//$UNIT//$DEC field reg $MESH2D as tissue
fem export elem;tissue_${UNIT}$DEC field reg $MESH2D as tissue


# Command updated by fixcom.sh on Wed Aug 23 17:49:58 NZT 2000
# Old command: fem export elem;tree_//$UNIT//$DEC field reg $TREE1D as tree
fem export elem;tree_${UNIT}$DEC field reg $TREE1D as tree


# Command updated by fixcom.sh on Wed Aug 23 17:49:58 NZT 2000
# Old command: ENDDO
}



# Command updated by fixcom.sh on Wed Aug 23 17:49:58 NZT 2000
# Old command: ENDDO
}



#See draw.com for viewing in cmgui
