$host_file = '3dcube';
$host_group = '3dcube';
$cleavage_file = 'cleavage';
$cleavage_group = 'cleavage';

#Read in Geometry Information
#============================
gfx read node $host_file
gfx read elem $host_file
gfx read node $cleavage_file
gfx read elem $cleavage_file

#Window Commands
#===============
gfx create window 1 double_buffer
gfx modify window 1 image scene default light_model default
gfx modify window 1 image add_light default
gfx modify window 1 layout simple ortho_axes z -y eye_spacing 0.25 width 469 height 490
gfx modify window 1 set current_pane 1
gfx modify window 1 background colour 0 0 0
gfx modify window 1 view parallel eye_point 0.5 0.5 3.3 interest_point 0.5 0.5 0.25 up_vector 0 1 0 view_angle 52.263 near_clipping_plane 0.0305985 far_clipping_plane 10.9348 relative_viewport ndc_placement -1 1 2 2 viewport_coordinates 0 0 1 1
gfx modify window 1 overlay scene none
gfx modify window 1 set transform current_pane 1 std_view_angle 40 normal_lines no_antialias fast_transparency

#gfx set visibility axes off

#Material Commands
#=================
gfx create material default ambient 1 1 1 diffuse 1 1 1 emission 0 0 0 specular 0 0 0 alpha 1 shininess 0
gfx create material isosurface ambient 0.5 0.51 1 diffuse 0.5 0.5 1 emission 0.1 0.1 0.1 specular 0.1 0.1 0.1 alpha 1 shininess 0.5
gfx create material yellow diff 1 1 0 amb 1 1 0 alpha 1
gfx create material red diff 1 0 0 amb 1 0 0
gfx create material extsurf amb 0 0 0 diffuse 0.2 0.2 0.5 alpha 0.2

#Spectrum Commands
#=================
gfx modify spectrum default clear overwrite_colour
gfx modify spectrum default linear reverse range -85.004 14.567 extend_above extend_below rainbow colour_range 0 1 ambient diffuse
## Create an appropriate spectrum
## Total Min. = -90, Total Max. =  50
gfx create spectrum potential log exaggeration 3 right reverse range -90 30 rainbow colour_range 0 1 ambient diffuse 

#Drawing Commands
#================

gfx modify g_element cube general circle_discretization 6 element_discretization "12*12*12" native_discretization coordinates
gfx modify g_element cube element_points glyph point size "1*1*1" label grid_point_number use_elements cell_corners native_discretization grid_point_number invisible

gfx modify g_element cube lines material yellow
#gfx modify g_element cube surfaces material extsurf

gfx modify g_element $cleavage_group surfaces material yellow
gfx modify g_element $cleavage_group lines material red

#Read in next time steps
#=======================

foreach $count ('000'..'050') {
 my $time = $count / 10;
 print "time: $time\n";

 gfx read element "gridfield_$count"       #read in the field
 gfx create iso_surface iso_scalar potential iso_value -40 coordinate coordinates material red from cube as wave time $time with "10*10*2"

 gfx create element_points use_elements native_discretization potential coordinate coordinates glyph diamond size 0.1 cell_corners material default data potential spectrum potential from cube as wavefield time $time

 gfx draw graphics_object wave
 gfx draw graphics_object wavefield
 gfx timekeeper default set_time $time
#gfx print file sprintf('gridfield_%3.3d.rgb',$count) rgb
}

# gfx set order cube

gfx timekeeper default play minimum 0 maximum 5
gfx timekeeper default stop set_time 0
gfx timekeeper default play speed 0.5
gfx create time_editor

