# Example b232
# ------------

fem define para;r;cube;example

fem define regi;r;cube;example              #two regions
fem define coor;r;region1;example reg 1     #rect.cartesian
fem define coor;r;region2;example reg 2     #rect.cartesian

fem define base;r;cube;example              #define linear basis functions
fem define node;r;cube;example              #define nodes for tissue sample
fem define elem;r;cube;example              #define elemnets for tissue sample

# cleavage planes must be plane (flat)
fem define node;r;cleavage;example reg 2 #nodes for cleavage plane elements
fem define elem;r;cleavage;example reg 2 #elements defining cleavage cuts

fem define fibr;d                   #default fibre angle
fem define elem;r;cube;example fibre
fem define grid;r;cube;example              #grid density
fem update grid geometry
fem group grid xi1=low as stimulus
fem update grid connectivity      #make grid pts adjacent to cleavage be bdry pts

if($TESTING) {
  fem list grid;connectivity connectivity
}
fem group grid external as boundary

fem define equa;r;cube;example              #cubic monodomain
fem define mate;r;cube;example

fem list grid group

# set num_threads 32

fem define cell;r;cube;example

fem define init;r;cube;example
fem define solv;r;cube;example

# cmgui output
fem export node;3dcube as cube reg 1
fem export elem;3dcube grid_numbers as cube reg 1
fem export node;cleavage as cleavage reg 2
fem export elem;cleavage as cleavage reg 2

fem solve to 0
fem export elem;"gridfield_000" field

# loop through time from 0 to 5 msec
foreach $count ( '001'..'050' ) {
 my $time = $count / 10;
 fem solve restart to "$time"
 print "time: $time\n";
 fem export elem;"gridfield_$count" field
}

#See draw.com to view results
