#Example_b32 4*4 small coupled electromechanics with solution. 
#
# Set up problem type definitions

$MECHANICS = 1
$ELECTRICS = 2
 
# Set up the geometry 4x4 elem 32*32mm bilinear basis
fem define para;r;emech;example

fem define node;r;emech-4x4;example
fem define base;r;emech;example
fem define elem;r;emech-4x4;example
fem define fibr;r;emech-0;example
fem define elem;r;emech-4x4;example fibre
fem define window;c

# Set up the mechanics
fem define equa;r;mech;example class $MECHANICS lock
fem define mate;r;mech;example
fem group node external as bdy_nodes
fem define init;r;mech;example
fem define solv;r;mech;example
fem define acti;r;mech;example

# Set up the electrical activation
fem define grid;r;elec-9x9;example class $ELECTRICS
fem update grid geometry
fem update grid metric
fem define equa;r;elec-vcd;example class $ELECTRICS
fem define cell;r;elec-vcd;example class $ELECTRICS
fem group grid external as boundary
fem define mate;r;elec-vcd;example class $ELECTRICS
fem update grid material class $ELECTRICS
fem group grid xi1=0 oneoff as lhs_line
fem define init;r;elec-lhs_line;example class $ELECTRICS
fem define solv;r;elec;example class $ELECTRICS
fem solve class $ELECTRICS to 0

# Solve the coupled equations
for $time ( 0..29 ) 
{
  fem solve class $ELECTRICS restart to $time
  fem update gauss calcium from_class $ELECTRICS
  fem solve class $MECHANICS incr 0. iter 99
  fem update grid geom deformed class $ELECTRICS from_class $MECHANICS
  fem update grid metric deformed class $ELECTRICS from_class $MECHANICS
  fem update grid material class $ELECTRICS
  fem draw field grid 1 class $ELECTRICS zmin=-120 zmax=20 noscale
  fem draw lines deformed rgb=white
  fem draw fibre deformed rgb=black
  refresh graphics
}
