#Example_b34 Coupled 2-D electro-mechanics example
 
# WARNING running this example may take a lot of time
 
# Create the geometry
fem define param;r;example_b34;example

fem define node;r;square16x16;example            #define 289 nodes
fem define base;r;membrane;example               #set up membrane
fem define element;r;square16x16;example         #define 256 elements
fem define fibre;r;sq16x16-10-90-10;example
fem define element;r;;example fibre
fem define window                            #create 2D xy window
#fem draw line                               !draw 4 mesh
#refresh graphics
#fem draw gauss                              !draw 3x3 gauss pts/element
 
# Set up the mechanics
fem define equation;r;stress;example class 1 lock  #define mechanics eqns
fem define material;r;membrane;example           #read params for mechs eqns
fem group node external as bdy_nodes         #all boundary nodes
#fem group node external xi1=0 as lhs_nodes  !nodes on left
#fem group node external xi1=1 as rhs_nodes  !nodes on right
#fem group node external xi2=0 as bot_nodes  !nodes at the bottom
#fem group node external xi2=1 as top_nodes  !nodes at the top
#fem define initial;r;prestress;example          !read i.c.s & b.c.s
fem define initial;r;fixed;example
fem define solve;r;membrane;example              #read solve params
fem define active;r;stress;example               #read active mechs params
#fem solve class 1 incr 1.                   !prestress membrane (top&right+8mm)
fem draw line deformed                       #draw new mesh
fem draw fibre def dxi 0.5,0.5,0.5 rgb=black
refresh graphics
 
# Set up the electrical activation
fem define grid;r;9x9;example class 2            #calc metrics on deformed grid
#fem update grid geom deformed
#fem update grid metric deformed
fem update grid geom
fem update grid metric
fem define equation;r;vcdc-is;example class 2    #define activation eqns
fem define material;r;vcd;example class 2        #read params for activation eqn
fem define cell;r;vcd;example class 2        #read params for activation eqn
fem update grid material class 2             #calc diffusivity tensor
fem group grid xi1=0 oneoff as lhs-line
fem group grid xi1=1 oneoff as rhs-line
fem group grid line 7873 xidirn 2 negative as cline
fem define initial;r;sq16x16-rhs-cline-v;example class 2  #read i.c.s & b.c.s
fem define solve;r;sq16x16;example class 2       #read solve params
fem solve class 2 to 0
 
#fem define;add base;r;quadbasis;example !biquadratic basis for grid-gauss interpolation

# Solve the equations
