#Example_c1  Solving for potential in spheres

             #This example tests the analytic solution to an eccentric
             #dipole inside a single sphere with the solution computed
             #by CMISS.  Note that the potential can be solved for up 
             #to an arbitrary additive constant, so matching needs to 
             #be performed if the analytic and computational solutions
             #are to be the same.  This is why 'define analytic' is 
             #done after the solve.

fem                            #Sets the environment to FEM.
fem define coordinates;r;eccentric_dipole;example #defines 3D rectangular.
fem define bases;r;;example        #Define 3 bicubic Hermite BEM basis.
fem define mesh;r;;example         #Generate a sphere of radius 2 with 4*4
#                              !  discretisation.
fem group node 1 as top        #Name the nodes for use with the initial
fem group node 2..13 as middle #  conditions.
fem group node 14 as bottom    #
fem define equation;r;;example     #Standard Laplace equation.
fem define material;r;;example     #No material definitions.
fem define source;r;;example       #Define an arbitrary dipole position,
#                              !  orientation and strength.
fem define initial;r;;example      #Fix the potential at the top of the
#                              !  sphere to 0.0.
fem define solve;r;;example        #Define solution parameters.
fem solve                      #Calculate the potential on the sphere.
fem define analytic;r;;example     #Define the analytic solution based on
#                              !  the calculated potential - ie the
#                              !  average potential of the analytic and
#                              !  computational solutions are the same.
fem check solution             #Compare analytic and computational
#                              !  solutions.
