#Example_c5  Solving for potential in 3 centric spheres due to an eccentric dipole

             #This example tests the analytic solution to an eccentric
             #dipole inside 3 concentric sphere with the solution computed
             #by CMISS.  Note that the potential can be solved for up 
             #to an arbitrary additive constant.

fem                            #Sets the environment to FEM.
fem define parameters;r;sphere;example

fem define coordinates;r;sphere;example #defines 3D rectangular.
fem define bases;r;;example        #Define 3 bicubic Hermite BEM basis.
fem define mesh;r;;example         #3 concentric spheres- 8*8 discretisation
fem define equation;r;;example region all  #Standard Laplace equation.
fem define material;r;;example region all  #No material definitions.
fem define source;r;;example       #Define an eccentric dipole
fem define analytic;r;;example region all
fem define coupling;r;;example	     #define the type of coupling
fem define initial;g region all      #generate the initial conditions
fem define solve;r;;example coupled region all  #Define coupled solution parameters.
fem solve coupled                    #Solve coupled problem
fem check solution             #Compare analytic and computational
#                              !  solutions.
