#
# start of testing
#


# 
# Create the surface electrodes
#  and export to CMGUI
#
fem def data;c from_xi                      region 1
fem def data;w;projected_positions          region 1
fem export data;projected_positions as projected_positions offset 3000
#                                              !outputs the data positions and 
#                                              !error vectors denoted by error


#
# Update the surface electrodes
# and export to UNEMAP
#
fem def import;r;import;example

# Command updated by fixcom.sh on Wed Aug 23 17:50:21 NZT 2000
# Old command: fem import signal;$example//eeg signal_output eeg_output extension sig
fem import signal;${example}eeg signal_output eeg_output extension sig

fem def data;r;projected_positions region 1
fem def xi;r;projections region 1
fem update signal infile eeg_output outfile eeg_updated binary
fem def export;r;unemap;example
fem export signal;eeg_updated electrodes signal eeg_updated


#
# Convert the signals to ASCII
#  for testing
#
fem conv signal from bin infile eeg_updated outfile eeg_updated


#
# Fit the signals
#
fem def fiel;r;head;example region 1           #set up field for fitting process
fem def elem;r;head;example field region 1     #elem fields 
fem def fit;r;head;example signal region 1
fem fit signal binary region 1
fem fit signal region 1


#
# Export the fitted signals at
#  each node to UNEMAP
#
fem evaluate electrodes;fitted_node hist fitted from node binary region 1 using fit
fem li sign bin sign fitted_node
fem conv signal from bin infile fitted_node outfile fitted_node
fem def export;r;nodes;example
fem export sig;fitted_node elec signal fitted_node


#
# Export reconstructed signals 
#  for a comparison
# 
fem def data;r;projected_positions region 1
fem def xi;r;projections region 1
fem evaluate electrodes;fitted_data hist fitted from data binary region 1 using fit
fem li sign bin sign fitted_data
fem conv signal from bin infile fitted_data outfile fitted_data


#
# Export the nodal signals to
#  UNEMAP
#
fem def export;r;unemap;example
fem export sig;fitted_data elec signal fitted_data


#
# Export the nodal potential
#  field to CMGUI
#
fem export node;potential hist fitted binary node 335..501 as potential region 1 using fit   
fem export elem;potential field elements 721..900 region 1 as potential using fit
