# This comfile reads in a *.ipxi file and converts it into an    #
#   ipnode file which can be read into CMISS                     #

if( !$example ) {
	$example = ".";
}

# Specify cmiss perl module
use CmUtils::File qw(cmRead cmWrite);

# Read in the volume mesh
fem define coor 3,1
fem define node;r;$example/Volume_mesh
fem define base;r;$example/sector
fem define elem;r;$example/Volume_mesh

# Generate the data points
fem define xi;r;$example/data
fem define data;c from_xi
fem define data;w;points

# Write out the ipnode
$group = cmRead( 'points.ipdata' );
$group->offset_number(109);
cmWrite( 'fibre.ipnode', $group );

