#----------------------------------------------------------------#
# draw.com                                                       #
#                                                                #
# Created by Martin Buist                                        #
#    August 2001                                                 #
#                                                                #
# This comfile draws the potential fields that result from the   #
#   comfile "solve.com". Use "anuimate.com for time dependent    #
#   solutions. Uncomment the "gfx print" line in animate.com to  #
#   write movie frames.                                          #
#                                                                #
#----------------------------------------------------------------#

# Read in the geometry and fields
gfx
gfx read node muscle_MB
gfx read elem muscle_MB
gfx read node muscle50
gfx read elem field0_MB
gfx read node fibre_MB
gfx read elem fibre_MB
gfx read elem fibre50

# Set up the window
gfx create win
gfx set vis axes off
gfx set res wid 640 hei 640
gfx modify window 1 view parallel eye_point 338.197 -439.363 -935.215 interest_point 204.099 228.263 -1030 up_vector -0.132172 0.113258 0.984735 view_angle 40 near_clipping_plane 6.87525 far_clipping_plane 2456.98 relative_viewport ndc_placement -1 1 2 2 viewport_coordinates 0 0 1 1
# Open the scene editor
gfx edit scene

# Draw the fibre
gfx modify g_element fibre_MB general clear circle_discretization 6 default_coordinate default_coordinate element_discretization "4*4*4" native_discretization potential
gfx modify g_element fibre_MB lines select_on material default selected_material default_selected
gfx modify g_element fibre_MB cylinders constant_radius 5 select_on material default data potential spectrum default selected_material default_selected

# Set up the spectrums for potential
gfx modify spectrum default clear overwrite_colour
gfx modify spectrum default linear reverse range -85 15 extend_above extend_below rainbow colour_range 0 1 ambient diffuse component 1
gfx create spectrum default+
gfx modify spectrum default+ clear overwrite_colour
gfx modify spectrum default+ linear reverse range -0.005 0.005 extend_above extend_below rainbow colour_range 0 1 ambient diffuse component 1

# Draw the muscle
gfx modify g_element muscle_MB general clear circle_discretization 6 default_coordinate default_coordinate element_discretization "4*4*4" native_discretization none
gfx modify g_element muscle_MB lines select_on material default selected_material default_selected
gfx modify g_element muscle_MB surfaces select_on material default data potential spectrum default+ selected_material default_selected render_wireframe

#open com animate exec
