if( $FITTING==1 )
{

#
#----------------------------#
# Fit the host mesh
#----------------------------#
#

fem def data;r;p111_landmark9;example reg $HOST

fem def xi;r;gen_landmark reg $HOST
fem export data;p111_landmark as p111_landmark error offset 17500 reg $HOST


#
#----------------------------#
# Tricubic fitting with 1 elem
#----------------------------#
#
#fem def field;r;host_cub;example       reg HOST
#fem def elem;r;host;example field      reg HOST
#fem def fit;r;host_tricub;example geom reg HOST


#
#----------------------------#
# Tricubic fitting with 2 elem
#----------------------------#
#
fem def field;r;host_cub_ref;example       reg $HOST
fem def elem;r;host_ref;example field      reg $HOST
fem def fit;r;host_tricub_ref;example geom reg $HOST


fem list data error reg $HOST                #Show starting error.
fem fit reg $HOST
fem update nodes reg $HOST
fem list data error reg $HOST                #Show final error.


fem def node;w;host_cust reg $HOST
fem def elem;w;host_cust reg $HOST


#
#----------------------------#
# Export customised host geometry
#----------------------------#
#
fem export nodes;host_cust as host_cust      offset 2000       reg $HOST
fem export elements;host_cust as host_cust   offset_elem 2000  reg $HOST
fem export data;data_cust as data_cust error offset 18000      reg $HOST


} #FITTING



if( $UPDATE==1 )
{

#
#----------------------------#
# Update the slave mesh
#----------------------------#
#

fem def node;r;host_cust reg $HOST
fem def elem;r;host_cust reg $HOST

fem def node;r;$SLAVEFILES;example reg $SLAVE
fem def elem;r;$SLAVEFILES;example reg $SLAVE
fem def xi;r;generic nodes of $SLAVE in $HOST


#
#----------------------------#
# Moves nodes of reg 2 
#  according to reg 1
#----------------------------#
#
fem up mesh posit of 1 in $HOST
fem up mesh posit of 6 in $HOST


#
#----------------------------#
# Export customised slave geometry
#----------------------------#
#
fem export node;pig_cust as pig_cust offset 20000      reg $SLAVE
fem export elem;pig_cust as pig_cust offset_elem 20000 reg $SLAVE


fem export elem;skin   as skin   reg 1    offset_elem 20000 elem 1281..2336
fem export elem;lungs  as lungs  reg 2..3 offset_elem 20000 
fem export elem;lvendo as lvendo reg 4    offset_elem 20000 
fem export elem;rvendo as rvendo reg 5    offset_elem 20000
fem export elem;heart  as heart  reg 6    offset_elem 20000 


# 
#----------------------------#
# Export electrodes for comparison
#----------------------------#
#
fem def data;r;electrode;example reg 1
fem def xi;c close reg 1
fem list data error reg 1
fem exp data;cust_error as cust_error error offset 24000 reg 1


} #UPDATE



if( $OUTPUT==1 )
{

fem def node;w;$CUSTFILES reg $SLAVE
fem def elem;w;$CUSTFILES reg $SLAVE

} #OUTPUT






