# Example e6 
# ----------
#


#----------------------------------------------------------#
#
# 2D torso slice simulation and inverse
#
#----------------------------------------------------------#


fem def para;r;torsoslice;example            #Sets up minimal parameter set.
fem def regi;r;torsoslice;example            #Two regions.
fem def node;r;;example region all           #Defines nodes for a 2D slice 
#                                            # through a torso and heart.
#fem define window;c
fem def base;r;;example                      #Defines a cubic Hermite BEM basis
#                                            # function.
fem def elem;r;;example region all           #Define 17 elements between heart 
#                                            # and torso.
#fem draw node region all                    #Draws the nodes around the torso 
#                                            # and heart.
#fem draw elements region all                #Draws the elements. Note that the
#                                            # elements lie around the boundary 
#                                            # of the slice, not running 
#                                            # 'through' it as they would with a
#                                            # FEM mesh.
#fem draw lines                              #We can now see the outline of the 
#                                            # 2D slice.
fem list elem region all total


#
#----------------------------#
# Setup equations
#----------------------------#
#
fem def equa;r;;example region all           #Defines a quasistatic analysis of 
#                                            # the standard Laplace equation.
fem def mate;r;;example region all
fem def init;r;;example region all
fem def sour;r;;example region 2             #Moving dipole inside heart.
fem def coup;r;;example                      #The type of coupling.
fem list coupling
