#!/usr/local/perl5.6/bin/perl
#

#CM -
#{

use Gtk;

#CM -
#attach gtk start_detection perl_action &cmiss::myloop() ;
init Gtk;
#CM -
#attach gtk end_detection ;

# Variable declarations -
# -----------------------
my $false = 0;
my $true = 1;
my $GridType = 0;

my $table;
my $window; 
my $vbox;

my @button;
my @entry;
my @hbox;
my @label;
my @radio;

# Graphics Subroutines -
# ----------------------

sub CloseAppWindow {
  # Callback function to close the window

  Gtk->exit( 0 );
  return $false;
}

sub ApplyCallback {
  # Call back function to read text input boxes
  # and act on the results

  my ( $widget, $entry, $radio ) = @_;

  $FILENAME = $entry[0]->get_text();
  $OUTSTRING = $entry[1]->get_text();
  $ScaleFactor = $entry[2]->get_text();
  $NodeOffset = $entry[3]->get_text();
  $NodeOffset = int($NodeOffset + 0.5);
  $GridX = $entry[4]->get_text();
  $GridY = $entry[5]->get_text();
  $GridZ = $entry[6]->get_text();
  $XjDirections = 2;
  @GridNumbers;

  ( $XjDirections, $XjExtremes ) = &Calculate_Geometry( $FILENAME, $XjDirections );
  ( $XjExtremes ) = &Apply_Scaling( $ScaleFactor, $XjExtremes );

  if( $radio[0]->active )
  {
    $GridType = 0;
  }
  else
  {
    $GridType = 1;
  }

  if( $GridType == 0 ) {
    # Set Grid Numbers
    $GridNumbers[0] = int($GridX + 0.5);
    $GridNumbers[1] = int($GridY + 0.5);
    $GridNumbers[2] = int($GridZ + 0.5);
  } else {
    # Set Grid Spacing
    $GridNumbers[0] = int((($XjExtremes[0] - $XjExtremes[1]) / $GridX) + 1.5);
    $GridNumbers[1] = int((($XjExtremes[2] - $XjExtremes[3]) / $GridY) + 1.5);
    $GridNumbers[2] = int((($XjExtremes[4] - $XjExtremes[5]) / $GridZ) + 1.5);
  }

  if( $XjDirections == 2 ) {
    &Write_IPNODE_2d( $OUTSTRING, $NodeOffset, $XjExtremes );
    &Write_IPBASE_2d( $OUTSTRING );
    &Write_IPELEM_2d( $OUTSTRING, $NodeOffset );
    &Write_IPGRID_2d( $OUTSTRING, $NodeOffset, $GridNumbers );
  } else {
    &Write_IPCOOR_3d( $OUTSTRING );
    &Write_IPNODE_3d( $OUTSTRING, $NodeOffset, $XjExtremes );
    &Write_IPBASE_3d( $OUTSTRING );
    &Write_IPELEM_3d( $OUTSTRING, $NodeOffset ); 
    &Write_IPGRID_3d( $OUTSTRING, $NodeOffset, $GridNumbers );
  }

  &Write_COMMAND_file( $OUTSTRING, $XjDirections );
}

# Computational Subroutines -
# ---------------------------

sub Apply_Scaling {
#----------------

  my ( $ScaleFactor, $XjExtremes ) = @_;

  my $LocalScaleFactor = ($ScaleFactor - 1.0) / 2.0;
  my $Xdistance = ($XjExtremes[0] - $XjExtremes[1]) * $LocalScaleFactor;
  my $Ydistance = ($XjExtremes[2] - $XjExtremes[3]) * $LocalScaleFactor;
  my $Zdistance = ($XjExtremes[4] - $XjExtremes[5]) * $LocalScaleFactor;

  
  $XjExtremes[0] = $XjExtremes[0] + $Xdistance;
  $XjExtremes[1] = $XjExtremes[1] - $Xdistance;
  $XjExtremes[2] = $XjExtremes[2] + $Ydistance;
  $XjExtremes[3] = $XjExtremes[3] - $Ydistance;
  $XjExtremes[4] = $XjExtremes[4] + $Zdistance;
  $XjExtremes[5] = $XjExtremes[5] - $Zdistance;
 
  return( $XjExtremes );

} # Apply_Scaling

sub Calculate_Geometry {
#---------------------

  my ( $FILENAME, $XjDirections ) = @_;
  my $Xj1, $Xj2, $Xj3;
  my @line;
  @XjExtremes = ( -10000, 10000, -10000, 10000, -10000, 10000 );

  CORE::open( INPUTFILE, "$FILENAME" ) or die( "ERROR: Unable to open input file" );

  while( <INPUTFILE> ) {

    # Number of global coordinates
    if( /Number of coordinates/ ) {
      @line = split;
      $XjDirections = $line[-1];
    }

    # Minimum and maximum X coordinates
    if( /Xj\(1\)/ ) {
      @line = split;
      $Xj1 = $line[-1];
      if ( $Xj1 > $XjExtremes[0] ) {
        $XjExtremes[0] = $Xj1;
      }
      if ( $Xj1 < $XjExtremes[1] ) {
        $XjExtremes[1] = $Xj1;
      }
    }

    # Minimum and maximum Y coordinates
    if( $XjDirections >= 2) {
      if( /Xj\(2\)/ ) {
        @line = split;
        $Xj2 = $line[-1];
        if ( $Xj2 > $XjExtremes[2] ) {
          $XjExtremes[2] = $Xj2;
        }
        if ( $Xj2 < $XjExtremes[3] ) {
          $XjExtremes[3] = $Xj2;
        }
      }
    }

    # Minimum and maximum Z coordinates
    if( $XjDirections == 3) {
      if( /Xj\(3\)/ ) {
        @line = split;
        $Xj3 = $line[-1];
        if ( $Xj3 > $XjExtremes[4] ) {
          $XjExtremes[4] = $Xj3;
        }
        if ( $Xj3 < $XjExtremes[5] ) {
          $XjExtremes[5] = $Xj3;
        }
      }
    }
  }

  CORE::close( INPUTFILE );

  return( $XjDirections, $XjExtremes );

} # Calculate_Geometry

sub Write_IPBASE_2d {
#------------------

  my ( $OUTSTRING ) = @_;

  CORE::open( OUTPUTFILE, ">$OUTSTRING\.ipbase" ) or die( "ERROR: Unable to open input file" );

  print( OUTPUTFILE ' CMISS Version 1.21 ipbase File Version 2'."\n" );
  print( OUTPUTFILE ' Heading:'."\n" );
  print( OUTPUTFILE ' '."\n" );
  print( OUTPUTFILE ' Enter the number of types of basis function [1]: 1'."\n" );
  print( OUTPUTFILE ' '."\n" );
  print( OUTPUTFILE ' For basis function type 1 the type of nodal interpolation is [1]:'."\n" );
  print( OUTPUTFILE '   (0) Auxiliary basis only'."\n" );
  print( OUTPUTFILE '   (1) Lagrange/Hermite tensor prod'."\n" );
  print( OUTPUTFILE '   (2) Simplex/Serendipity/Sector'."\n" );
  print( OUTPUTFILE '   (3) B-spline tensor product'."\n" );
  print( OUTPUTFILE '   (4) Fourier Series/Lagrange/Hermite tensor prod'."\n" );
  print( OUTPUTFILE '   (5) Boundary Element Lagrange/Hermite tensor pr.'."\n" );
  print( OUTPUTFILE '   (6) Boundary Element Simplex/Serendipity/Sector'."\n" );
  print( OUTPUTFILE '   (7) Extended Lagrange (multigrid collocation)'."\n" );
  print( OUTPUTFILE '    1'."\n" );
  print( OUTPUTFILE ' Enter the number of Xi-coordinates [1]: 2'."\n" );
  print( OUTPUTFILE ' '."\n" );
  print( OUTPUTFILE ' The interpolant in the Xi(1) direction is [1]:'."\n" );
  print( OUTPUTFILE '   (1) Linear Lagrange'."\n" );
  print( OUTPUTFILE '   (2) Quadratic Lagrange'."\n" );
  print( OUTPUTFILE '   (3) Cubic Lagrange'."\n" );
  print( OUTPUTFILE '   (4) Quadratic Hermite'."\n" );
  print( OUTPUTFILE '   (5) Cubic Hermite'."\n" );
  print( OUTPUTFILE '    1'."\n" );
  print( OUTPUTFILE ' Enter the number of Gauss points in the Xi(1) direction [2]: 2'."\n" );
  print( OUTPUTFILE ' '."\n" );
  print( OUTPUTFILE ' The interpolant in the Xi(2) direction is [1]:'."\n" );
  print( OUTPUTFILE '   (1) Linear Lagrange'."\n" );
  print( OUTPUTFILE '   (2) Quadratic Lagrange'."\n" );
  print( OUTPUTFILE '   (3) Cubic Lagrange'."\n" );
  print( OUTPUTFILE '   (4) Quadratic Hermite'."\n" );
  print( OUTPUTFILE '   (5) Cubic Hermite'."\n" );
  print( OUTPUTFILE '    1'."\n" );
  print( OUTPUTFILE ' Enter the number of Gauss points in the Xi(2) direction [2]: 2'."\n" );
  print( OUTPUTFILE ' Enter the node position indices [11211222]: 1 1 2 1 1 2 2 2'."\n" );
  print( OUTPUTFILE ' Enter the number of auxiliary element parameters [0]: 0'."\n" );

  CORE::close( OUTPUTFILE );

} # Write_IPBASE_2d

sub Write_IPBASE_3d {
#------------------

  my ( $OUTSTRING ) = @_;

  CORE::open( OUTPUTFILE, ">$OUTSTRING\.ipbase" ) or die( "ERROR: Unable to open input file" );

  print( OUTPUTFILE ' CMISS Version 1.21 ipbase File Version 2'."\n" );
  print( OUTPUTFILE ' Heading:'."\n" );
  print( OUTPUTFILE ' '."\n" );
  print( OUTPUTFILE ' Enter the number of types of basis function [1]: 2'."\n" );
  print( OUTPUTFILE ' '."\n" );
  print( OUTPUTFILE ' For basis function type 1 the type of nodal interpolation is [1]:'."\n" );
  print( OUTPUTFILE '   (0) Auxiliary basis only'."\n" );
  print( OUTPUTFILE '   (1) Lagrange/Hermite tensor prod'."\n" );
  print( OUTPUTFILE '   (2) Simplex/Serendipity/Sector'."\n" );
  print( OUTPUTFILE '   (3) B-spline tensor product'."\n" );
  print( OUTPUTFILE '   (4) Fourier Series/Lagrange/Hermite tensor prod'."\n" );
  print( OUTPUTFILE '   (5) Boundary Element Lagrange/Hermite tensor pr.'."\n" );
  print( OUTPUTFILE '   (6) Boundary Element Simplex/Serendipity/Sector'."\n" );
  print( OUTPUTFILE '   (7) Extended Lagrange (multigrid collocation)'."\n" );
  print( OUTPUTFILE '    1'."\n" );
  print( OUTPUTFILE ' Enter the number of Xi-coordinates [1]: 3'."\n" );
  print( OUTPUTFILE ' '."\n" );
  print( OUTPUTFILE ' The interpolant in the Xi(1) direction is [1]:'."\n" );
  print( OUTPUTFILE '   (1) Linear Lagrange'."\n" );
  print( OUTPUTFILE '   (2) Quadratic Lagrange'."\n" );
  print( OUTPUTFILE '   (3) Cubic Lagrange'."\n" );
  print( OUTPUTFILE '   (4) Quadratic Hermite'."\n" );
  print( OUTPUTFILE '   (5) Cubic Hermite'."\n" );
  print( OUTPUTFILE '    1'."\n" );
  print( OUTPUTFILE ' Enter the number of Gauss points in the Xi(1) direction [2]: 2'."\n" );
  print( OUTPUTFILE ' '."\n" );
  print( OUTPUTFILE ' The interpolant in the Xi(2) direction is [1]:'."\n" );
  print( OUTPUTFILE '   (1) Linear Lagrange'."\n" );
  print( OUTPUTFILE '   (2) Quadratic Lagrange'."\n" );
  print( OUTPUTFILE '   (3) Cubic Lagrange'."\n" );
  print( OUTPUTFILE '   (4) Quadratic Hermite'."\n" );
  print( OUTPUTFILE '   (5) Cubic Hermite'."\n" );
  print( OUTPUTFILE '    1'."\n" );
  print( OUTPUTFILE ' Enter the number of Gauss points in the Xi(2) direction [2]: 2'."\n" );
  print( OUTPUTFILE ' '."\n" );
  print( OUTPUTFILE ' The interpolant in the Xi(3) direction is [1]:'."\n" );
  print( OUTPUTFILE '   (1) Linear Lagrange'."\n" );
  print( OUTPUTFILE '   (2) Quadratic Lagrange'."\n" );
  print( OUTPUTFILE '   (3) Cubic Lagrange'."\n" );
  print( OUTPUTFILE '   (4) Quadratic Hermite'."\n" );
  print( OUTPUTFILE '   (5) Cubic Hermite'."\n" );
  print( OUTPUTFILE '    1'."\n" );
  print( OUTPUTFILE ' Enter the number of Gauss points in the Xi(3) direction [2]: 2'."\n" );
  print( OUTPUTFILE ' Enter the node position indices [111211121221112212122222]: 1 1 1 2 1 1 1 2 1 2 2 1 1 1 2 2 1 2 1 2 2 2 2 2'."\n" );
  print( OUTPUTFILE ' Enter the number of auxiliary element parameters [0]: 0'."\n" );
  print( OUTPUTFILE ' '."\n" );
  print( OUTPUTFILE ' For basis function type 2 the type of nodal interpolation is [1]:'."\n" );
  print( OUTPUTFILE '   (0) Auxiliary basis only'."\n" );
  print( OUTPUTFILE '   (1) Lagrange/Hermite tensor prod'."\n" );
  print( OUTPUTFILE '   (2) Simplex/Serendipity/Sector'."\n" );
  print( OUTPUTFILE '   (3) B-spline tensor product'."\n" );
  print( OUTPUTFILE '   (4) Fourier Series/Lagrange/Hermite tensor prod'."\n" );
  print( OUTPUTFILE '   (5) Boundary Element Lagrange/Hermite tensor pr.'."\n" );
  print( OUTPUTFILE '   (6) Boundary Element Simplex/Serendipity/Sector'."\n" );
  print( OUTPUTFILE '   (7) Extended Lagrange (multigrid collocation)'."\n" );
  print( OUTPUTFILE '    1'."\n" );
  print( OUTPUTFILE ' Enter the number of Xi-coordinates [1]: 2'."\n" );
  print( OUTPUTFILE ' '."\n" );
  print( OUTPUTFILE ' The interpolant in the Xi(1) direction is [1]:'."\n" );
  print( OUTPUTFILE '   (1) Linear Lagrange'."\n" );
  print( OUTPUTFILE '   (2) Quadratic Lagrange'."\n" );
  print( OUTPUTFILE '   (3) Cubic Lagrange'."\n" );
  print( OUTPUTFILE '   (4) Quadratic Hermite'."\n" );
  print( OUTPUTFILE '   (5) Cubic Hermite'."\n" );
  print( OUTPUTFILE '    1'."\n" );
  print( OUTPUTFILE ' Enter the number of Gauss points in the Xi(1) direction [1]: 1'."\n" );
  print( OUTPUTFILE ' '."\n" );
  print( OUTPUTFILE ' The interpolant in the Xi(2) direction is [1]:'."\n" );
  print( OUTPUTFILE '   (1) Linear Lagrange'."\n" );
  print( OUTPUTFILE '   (2) Quadratic Lagrange'."\n" );
  print( OUTPUTFILE '   (3) Cubic Lagrange'."\n" );
  print( OUTPUTFILE '   (4) Quadratic Hermite'."\n" );
  print( OUTPUTFILE '   (5) Cubic Hermite'."\n" );
  print( OUTPUTFILE '    1'."\n" );
  print( OUTPUTFILE ' Enter the number of Gauss points in the Xi(2) direction [1]: 1'."\n" );
  print( OUTPUTFILE ' Enter the node position indices [11211222]: 1 1 2 1 1 2 2 2'."\n" );
  print( OUTPUTFILE ' Enter the number of auxiliary element parameters [0]: 0'."\n" );

  CORE::close( OUTPUTFILE );

} # Write_IPBASE_3d

sub Write_COMMAND_file {
#---------------------

  my ( $OUTSTRING, $XjDirections ) = @_;  

  CORE::open( OUTPUTFILE, ">$OUTSTRING\.com" ) or die( "ERROR: Unable to open input file" );

  if( $XjDirections == 3 ) {
    print( OUTPUTFILE 'FEM define coor;r;'."$OUTSTRING\n" );    
  }
  print( OUTPUTFILE 'FEM define node;r;'."$OUTSTRING\n" );
  print( OUTPUTFILE 'FEM define base;r;'."$OUTSTRING\n" );
  print( OUTPUTFILE 'FEM define elem;r;'."$OUTSTRING\n" );
  print( OUTPUTFILE 'FEM define grid;r;'."$OUTSTRING\n" );
  print( OUTPUTFILE 'FEM update grid geometry '."\n" );

  CORE::close( OUTPUTFILE );

} # Write_COMMAND_file

sub Write_IPCOOR_3d {
#------------------

  my ( $OUTSTRING ) = @_;  

  CORE::open( OUTPUTFILE, ">$OUTSTRING\.ipcoor" ) or die( "ERROR: Unable to open input file" );

  print( OUTPUTFILE ' CMISS Version 1.21 ipcoor File Version 1'."\n" );
  print( OUTPUTFILE ' Heading:'."\n" );
  print( OUTPUTFILE ' '."\n" );
  print( OUTPUTFILE ' The global coordinates for region 1 are [1]:'."\n" );
  print( OUTPUTFILE '   (1) rectangular cartesian (x,y,z)'."\n" );
  print( OUTPUTFILE '   (2) cylindrical polar (r,theta,z)'."\n" );
  print( OUTPUTFILE '   (3) spherical polar (r,theta,phi)'."\n" );
  print( OUTPUTFILE '   (4) prolate spheroidal (lambda,mu,theta)'."\n" );
  print( OUTPUTFILE '   (5) oblate  spheroidal (lambda,mu,theta)'."\n" );
  print( OUTPUTFILE '    1'."\n" );
  print( OUTPUTFILE ' Enter the number of global coordinates [2]: 3'."\n" );
  print( OUTPUTFILE ' Do you want to specify another coord. system for dependent variables [N]? N'."\n" );
  print( OUTPUTFILE ' Enter x,y,z origin of coords relative to region 0 [0,0,0]:0.00000D+00  0.00000D+00  0.00000D+00'."\n" );
  print( OUTPUTFILE ' Are there any non-standard mappings [N]? N'."\n" );

  CORE::close( OUTPUTFILE );

} # Write_IPCOOR_3d

sub Write_IPELEM_2d {
#------------------

  my ( $OUTSTRING, $NodeOffset ) = @_;  
  my $i = $NodeOffset + 1;
  my $j = $NodeOffset + 2;
  my $k = $NodeOffset + 3;
  my $l = $NodeOffset + 4;

  CORE::open( OUTPUTFILE, ">$OUTSTRING\.ipelem" ) or die( "ERROR: Unable to open input file" );

  print( OUTPUTFILE ' CMISS Version 1.21 ipelem File Version 2'."\n" );
  print( OUTPUTFILE ' Heading:'."\n" );
  print( OUTPUTFILE ' '."\n" );
  print( OUTPUTFILE ' The number of elements is [1]: 1'."\n" );
  print( OUTPUTFILE ' '."\n" );
  print( OUTPUTFILE ' Element number [    1]: '."$i\n" );
  print( OUTPUTFILE ' The number of geometric Xj-coordinates is [2]: 2'."\n" );
  print( OUTPUTFILE ' The basis function type for geometric variable 1 is [1]: 1'."\n" );
  print( OUTPUTFILE ' The basis function type for geometric variable 2 is [1]: 1'."\n" );
  print( OUTPUTFILE ' Enter the 4 global numbers for basis 1: '."$i $j $k $l\n" );

  CORE::close( OUTPUTFILE );

} # Write_IPELEM_2d

sub Write_IPELEM_3d {
#------------------

  my ( $OUTSTRING, $NodeOffset ) = @_;  
  my $i = $NodeOffset + 1;
  my $j = $NodeOffset + 2;
  my $k = $NodeOffset + 3;
  my $l = $NodeOffset + 4;
  my $m = $NodeOffset + 5;
  my $n = $NodeOffset + 6;
  my $o = $NodeOffset + 7;
  my $p = $NodeOffset + 8;

  CORE::open( OUTPUTFILE, ">$OUTSTRING\.ipelem" ) or die( "ERROR: Unable to open input file" );

  print( OUTPUTFILE ' CMISS Version 1.21 ipelem File Version 2'."\n" );
  print( OUTPUTFILE ' Heading:'."\n" );
  print( OUTPUTFILE ' '."\n" );
  print( OUTPUTFILE ' The number of elements is [1]: 1'."\n" );
  print( OUTPUTFILE ' '."\n" );
  print( OUTPUTFILE ' Element number [    1]: '."$i\n" );
  print( OUTPUTFILE ' The number of geometric Xj-coordinates is [3]: 3'."\n" );
  print( OUTPUTFILE ' The basis function type for geometric variable 1 is [1]: 1'."\n" );
  print( OUTPUTFILE ' The basis function type for geometric variable 2 is [1]: 1'."\n" );
  print( OUTPUTFILE ' The basis function type for geometric variable 3 is [1]: 1'."\n" );
  print( OUTPUTFILE ' Enter the 8 global numbers for basis 1: '."$i $j $k $l $m $n $o $p\n" );

  CORE::close( OUTPUTFILE );

} # Write_IPELEM_3d

sub Write_IPGRID_2d {
#------------------

  my ( $OUTSTRING, $NodeOffset, $GridNumbers ) = @_;  
  my $i = $NodeOffset + 1;

  CORE::open( OUTPUTFILE, ">$OUTSTRING\.ipgrid" ) or die( "ERROR: Unable to open input file" );

  print( OUTPUTFILE ' CMISS Version 1.21 ipgrid File Version 1'."\n" );
  print( OUTPUTFILE ' Heading:'."\n" );
  print( OUTPUTFILE ' '."\n" );
  print( OUTPUTFILE ' The number of grid schemes is [1]: 1'."\n" );
  print( OUTPUTFILE ' Enter the interpolating basis function for scheme 1 [1]: 1'."\n" );
  print( OUTPUTFILE ' Enter the number of xi coordinates for scheme 1 [1]: 2'."\n" );
  print( OUTPUTFILE ' Enter the number of collocation points in xi 1 direction [1]: '."$GridNumbers[0]\n" );
  print( OUTPUTFILE ' Enter the number of collocation points in xi 2 direction [1]: '."$GridNumbers[1]\n" );
  print( OUTPUTFILE ' Enter the number of grid levels [1]: 1'."\n" );
  print( OUTPUTFILE ' Enter element #s/name [EXIT]: '."$i\n" );
  print( OUTPUTFILE ' Enter the grid scheme number for element(s) [1]: 1'."\n" );
  print( OUTPUTFILE ' Enter element #s/name [EXIT]:  0'."\n" );

  CORE::close( OUTPUTFILE );

} # Write_IPGRID_2d

sub Write_IPGRID_3d {
#------------------

  my ( $OUTSTRING, $NodeOffset, $GridNumbers ) = @_;  
  my $i = $NodeOffset + 1;

  CORE::open( OUTPUTFILE, ">$OUTSTRING\.ipgrid" ) or die( "ERROR: Unable to open input file" );

  print( OUTPUTFILE ' CMISS Version 1.21 ipgrid File Version 1'."\n" );
  print( OUTPUTFILE ' Heading:'."\n" );
  print( OUTPUTFILE ' '."\n" );
  print( OUTPUTFILE ' The number of grid schemes is [1]: 1'."\n" );
  print( OUTPUTFILE ' Enter the interpolating basis function for scheme 1 [1]: 1'."\n" );
  print( OUTPUTFILE ' Enter the number of xi coordinates for scheme 1 [1]: 3'."\n" );
  print( OUTPUTFILE ' Enter the number of collocation points in xi 1 direction [1]: '."$GridNumbers[0]\n" );
  print( OUTPUTFILE ' Enter the number of collocation points in xi 2 direction [1]: '."$GridNumbers[1]\n" );
  print( OUTPUTFILE ' Enter the number of collocation points in xi 3 direction [1]: '."$GridNumbers[2]\n" );
  print( OUTPUTFILE ' Enter the number of grid levels [1]: 1'."\n" );
  print( OUTPUTFILE ' Enter element #s/name [EXIT]: '."$i\n" );
  print( OUTPUTFILE ' Enter the grid scheme number for element(s) [1]: 1'."\n" );
  print( OUTPUTFILE ' Enter element #s/name [EXIT]:  0'."\n" );

  CORE::close( OUTPUTFILE );

} # Write_IPGRID_3d

sub Write_IPNODE_2d {
#------------------

  my ( $OUTSTRING, $NodeOffset, $XjExtremes ) = @_;  
  my $i = $NodeOffset + 1;

  CORE::open( OUTPUTFILE, ">$OUTSTRING\.ipnode" ) or die( "ERROR: Unable to open input file" );

  print( OUTPUTFILE ' CMISS Version 1.21 ipnode File Version 2'."\n" );
  print( OUTPUTFILE ' Heading:'."\n" );
  print( OUTPUTFILE ' '."\n" );
  print( OUTPUTFILE ' The number of nodes is [    1]: 4'."\n" );
  print( OUTPUTFILE ' Number of coordinates [2]: 2'."\n" );
  print( OUTPUTFILE ' Do you want prompting for different versions of nj=1 [N]? N'."\n" );
  print( OUTPUTFILE ' Do you want prompting for different versions of nj=2 [N]? N'."\n" );
  print( OUTPUTFILE ' The number of derivatives for coordinate 1 is [0]: 0'."\n" );
  print( OUTPUTFILE ' The number of derivatives for coordinate 2 is [0]: 0'."\n" );
  print( OUTPUTFILE ' '."\n" );
  print( OUTPUTFILE ' Node number [    1]: '."$i\n" );
  $i++;
  print( OUTPUTFILE ' The Xj(1) coordinate is [ 0.00000E+00]: '."$XjExtremes[1]\n" );
  print( OUTPUTFILE ' The Xj(2) coordinate is [ 0.00000E+00]: '."$XjExtremes[3]\n" );
  print( OUTPUTFILE ' '."\n" );
  print( OUTPUTFILE ' Node number [    2]: '."$i\n" );
  $i++;
  print( OUTPUTFILE ' The Xj(1) coordinate is [ 0.00000E+00]: '."$XjExtremes[0]\n" );
  print( OUTPUTFILE ' The Xj(2) coordinate is [ 0.00000E+00]: '."$XjExtremes[3]\n" );
  print( OUTPUTFILE ' '."\n" );
  print( OUTPUTFILE ' Node number [    3]: '."$i\n" );
  $i++;
  print( OUTPUTFILE ' The Xj(1) coordinate is [ 0.00000E+00]: '."$XjExtremes[1]\n" );
  print( OUTPUTFILE ' The Xj(2) coordinate is [ 0.00000E+00]: '."$XjExtremes[2]\n" );
  print( OUTPUTFILE ' '."\n" );
  print( OUTPUTFILE ' Node number [    4]: '."$i\n" );
  print( OUTPUTFILE ' The Xj(1) coordinate is [ 0.00000E+00]: '."$XjExtremes[0]\n" );
  print( OUTPUTFILE ' The Xj(2) coordinate is [ 0.00000E+00]: '."$XjExtremes[2]\n" );

  CORE::close( OUTPUTFILE );

} # Write_IPNODE_2d

sub Write_IPNODE_3d {
#------------------

  my ( $OUTSTRING, $NodeOffset, $XjExtremes ) = @_;  
  my $i = $NodeOffset + 1;

  CORE::open( OUTPUTFILE, ">$OUTSTRING\.ipnode" ) or die( "ERROR: Unable to open input file" );

  print( OUTPUTFILE ' CMISS Version 1.21 ipnode File Version 2'."\n" );
  print( OUTPUTFILE ' Heading:'."\n" );
  print( OUTPUTFILE ' '."\n" );
  print( OUTPUTFILE ' The number of nodes is [    1]: 8'."\n" );
  print( OUTPUTFILE ' Number of coordinates [3]: 3'."\n" );
  print( OUTPUTFILE ' Do you want prompting for different versions of nj=1 [N]? N'."\n" );
  print( OUTPUTFILE ' Do you want prompting for different versions of nj=2 [N]? N'."\n" );
  print( OUTPUTFILE ' Do you want prompting for different versions of nj=3 [N]? N'."\n" );
  print( OUTPUTFILE ' The number of derivatives for coordinate 1 is [0]: 0'."\n" );
  print( OUTPUTFILE ' The number of derivatives for coordinate 2 is [0]: 0'."\n" );
  print( OUTPUTFILE ' The number of derivatives for coordinate 3 is [0]: 0'."\n" );
  print( OUTPUTFILE ' '."\n" );
  print( OUTPUTFILE ' Node number [    1]: '."$i\n" );
  $i++;
  print( OUTPUTFILE ' The Xj(1) coordinate is [ 0.00000E+00]: '."$XjExtremes[1]\n" );
  print( OUTPUTFILE ' The Xj(2) coordinate is [ 0.00000E+00]: '."$XjExtremes[3]\n" );
  print( OUTPUTFILE ' The Xj(3) coordinate is [ 0.00000E+00]: '."$XjExtremes[5]\n" );
  print( OUTPUTFILE ' '."\n" );
  print( OUTPUTFILE ' Node number [    2]: '."$i\n" );
  $i++;
  print( OUTPUTFILE ' The Xj(1) coordinate is [ 0.00000E+00]: '."$XjExtremes[0]\n" );
  print( OUTPUTFILE ' The Xj(2) coordinate is [ 0.00000E+00]: '."$XjExtremes[3]\n" );
  print( OUTPUTFILE ' The Xj(3) coordinate is [ 0.00000E+00]: '."$XjExtremes[5]\n" );
  print( OUTPUTFILE ' '."\n" );
  print( OUTPUTFILE ' Node number [    3]: '."$i\n" );
  $i++;
  print( OUTPUTFILE ' The Xj(1) coordinate is [ 0.10000E+01]: '."$XjExtremes[1]\n" );
  print( OUTPUTFILE ' The Xj(2) coordinate is [ 0.00000E+00]: '."$XjExtremes[2]\n" );
  print( OUTPUTFILE ' The Xj(3) coordinate is [ 0.00000E+00]: '."$XjExtremes[5]\n" );
  print( OUTPUTFILE ' '."\n" );
  print( OUTPUTFILE ' Node number [    4]: '."$i\n" );
  $i++;
  print( OUTPUTFILE ' The Xj(1) coordinate is [ 0.00000E+00]: '."$XjExtremes[0]\n" );
  print( OUTPUTFILE ' The Xj(2) coordinate is [ 0.10000E+01]: '."$XjExtremes[2]\n" );
  print( OUTPUTFILE ' The Xj(3) coordinate is [ 0.00000E+00]: '."$XjExtremes[5]\n" );
  print( OUTPUTFILE ' '."\n" );
  print( OUTPUTFILE ' Node number [    5]: '."$i\n" );
  $i++;
  print( OUTPUTFILE ' The Xj(1) coordinate is [ 0.10000E+01]: '."$XjExtremes[1]\n" );
  print( OUTPUTFILE ' The Xj(2) coordinate is [ 0.10000E+01]: '."$XjExtremes[3]\n" );
  print( OUTPUTFILE ' The Xj(3) coordinate is [ 0.00000E+00]: '."$XjExtremes[4]\n" );
  print( OUTPUTFILE ' '."\n" );
  print( OUTPUTFILE ' Node number [    6]: '."$i\n" );
  $i++;
  print( OUTPUTFILE ' The Xj(1) coordinate is [ 0.00000E+00]: '."$XjExtremes[0]\n" );
  print( OUTPUTFILE ' The Xj(2) coordinate is [ 0.00000E+00]: '."$XjExtremes[3]\n" );
  print( OUTPUTFILE ' The Xj(3) coordinate is [ 0.10000E+01]: '."$XjExtremes[4]\n" );
  print( OUTPUTFILE ' '."\n" );
  print( OUTPUTFILE ' Node number [    7]: '."$i\n" );
  $i++;
  print( OUTPUTFILE ' The Xj(1) coordinate is [ 0.10000E+01]: '."$XjExtremes[1]\n" );
  print( OUTPUTFILE ' The Xj(2) coordinate is [ 0.00000E+00]: '."$XjExtremes[2]\n" );
  print( OUTPUTFILE ' The Xj(3) coordinate is [ 0.10000E+01]: '."$XjExtremes[4]\n" );
  print( OUTPUTFILE ' '."\n" );
  print( OUTPUTFILE ' Node number [    8]: '."$i\n" );
  print( OUTPUTFILE ' The Xj(1) coordinate is [ 0.00000E+00]: '."$XjExtremes[0]\n" );
  print( OUTPUTFILE ' The Xj(2) coordinate is [ 0.10000E+01]: '."$XjExtremes[2]\n" );
  print( OUTPUTFILE ' The Xj(3) coordinate is [ 0.10000E+01]: '."$XjExtremes[4]\n" );

  CORE::close( OUTPUTFILE );

} # Write_IPNODE_3d

# ------------------------------------------------------------------------------

# Main Program -
# --------------

# Create a window
# ---------------
$window = new Gtk::Window( "toplevel" );
$window->set_title( "Streamline Creator" );
$window->signal_connect( 'delete_event', \&CloseAppWindow );
$window->border_width( 10 );

# Whole window is a Vbox
# ----------------------
$vbox = new Gtk::VBox( $false, 10 );
$window->add( $vbox );
$vbox->show();

# Create a table for dialogs
# --------------------------
$table = new Gtk::Table( 6, 2, $true ); 
$vbox->pack_start( $table, $false, $false, 0 );
$table->set_row_spacings( 10 );
$table->show();

# First row of the table
# text input file entry
# ----------------------
$label[0] = new Gtk::Label( 'Node File Name' );
$label[0]->set_alignment( 0, 0 );
$table->attach_defaults( $label[0], 0, 1, 0, 1 );
$label[0]->show();

$entry[0] = new Gtk::Entry( 32 );
$entry[0]->set_text( 'bemcircle.ipnode' );
$table->attach_defaults( $entry[0], 1, 2, 0, 1 );
$entry[0]->show();

# Second row of the table
# text output file entry
# -----------------------
$label[1] = new Gtk::Label( 'Output File Prefix' );
$label[1]->set_alignment( 0, 0 );
$table->attach_defaults( $label[1], 0, 1, 1, 2 );
$label[1]->show();

$entry[1] = new Gtk::Entry( 32 );
$entry[1]->set_text( "test" );
$table->attach_defaults( $entry[1], 1, 2, 1, 2 );
$entry[1]->show();

# Third row of the table
# text scale factor entry
# -----------------------
$label[2] = new Gtk::Label( 'Scale Factor' );
$label[2]->set_alignment( 0, 0 );
$table->attach_defaults( $label[2], 0, 1, 2, 3 );
$label[2]->show();

$entry[2] = new Gtk::Entry( 32 );
$entry[2]->set_text( "1.0" );
$table->attach_defaults( $entry[2], 1, 2, 2, 3 );
$entry[2]->show();

# Fourth row of the table
# Node/elem offset
# -----------------------
$label[3] = new Gtk::Label( 'Node number offset' );
$label[3]->set_alignment( 0, 0 );
$table->attach_defaults( $label[3], 0, 1, 3, 4 );
$label[3]->show();

$entry[3] = new Gtk::Entry( 32 );
$entry[3]->set_text( "100" );
$table->attach_defaults( $entry[3], 1, 2, 3, 4 );
$entry[3]->show();

# Fifth row of the table
# radio grid dx or number
# -----------------------
$radio[0] = new Gtk::RadioButton( "Set Grid Numbers" );
$radio[0]->set_active( $true );
$table->attach_defaults( $radio[0], 0, 1, 4, 5 );
$radio[0]->show();

$radio[1] = new Gtk::RadioButton( "Set Grid Spacing", $radio[0] );
$table->attach_defaults( $radio[1], 1, 2, 4, 5);
$radio[1]->show();

# Sixth row of table
# grid spacings/numbers
# ---------------------
$label[4] = new Gtk::Label( 'X Y Z' );
$label[4]->set_alignment( 0, 0 );
$table->attach_defaults( $label[4], 0, 1, 5, 6 );
$label[4]->show();

$hbox[0] = new Gtk::HBox();
$table->attach_defaults( $hbox[0], 1, 2, 5, 6 );
$hbox[0]->show();

$entry[4] = new Gtk::Entry( "8" );
$entry[4]->set_text( "3" );
$entry[4]->set_usize( 50, 0 );
$hbox[0]->pack_start( $entry[4], $false, $false, 0 );
$entry[4]->show();

$entry[5] = new Gtk::Entry( "8" );
$entry[5]->set_text( "3" );
$entry[5]->set_usize( 50, 0 );
$hbox[0]->pack_start( $entry[5], $false, $false, 0 );
$entry[5]->show();

$entry[6] = new Gtk::Entry( "8" );
$entry[6]->set_text( "3" );
$entry[6]->set_usize( 50, 0 );
$hbox[0]->pack_start( $entry[6], $false, $false, 0 );
$entry[6]->show();

# Line between buttons and table
# ------------------------------
$separator = new Gtk::HSeparator();
$vbox->pack_start( $separator, $false, $true, 0 );
$separator->show();

# Buttons Hbox
# ------------
$hbox[1] = new Gtk::HBox();
$vbox->pack_start( $hbox[1], $false, $false, 0 );
$hbox[1]->show();

$button[0] = new Gtk::Button( "Apply" );
$button[0]->signal_connect( "clicked", \&ApplyCallback, $entry, $radio );
$hbox[1]->pack_start( $button[0], $true, $true, 0 );
$button[0]->can_default( $true );
$button[0]->grab_default();
$button[0]->show();

$button[1] = new Gtk::Button( "Close" );
$button[1]->signal_connect( "clicked", \&CloseAppWindow );
$hbox[1]->pack_start( $button[1], $true, $true, 0 );
$button[1]->show();

# Show main window
# ----------------
$window->show();

# Gtk main loop
# -------------
main Gtk;
exit( 0 );

#CM -
#sub myloop {
#  while (Gtk->events_pending()) {
#    Gtk->main_iteration();
#  }
#  return ("OK");
#}
#CM -
#myloop;
#CM -
#}
