#
# Created by Martin Buist
# August 2001
#

if( !$example ) {
  $example = ".";
}

fem define para;r;$example/3dtest
fem define coord 3,1          
fem define regi;r;$example/3dtest
fem define node;r;$example/8x8
fem define node;r;$example/3dtest reg 2
fem define bas;r;$example/test
fem define elem;r;$example/8x8
fem define elem;r;$example/3dtest reg 2
fem define grid;r;$example/3dtest reg 2
fem update grid geometry reg 2
fem define equation;r;$example/bemsphere cl 1 lock
fem define equa;r;$example/3dtest cl 2 lock reg 2
fem define material;r;$example/bemsphere 
fem define anal;r;$example/bemsphere
fem define initial;g 
fem define solve;r;$example/bemsphere
fem solve

fem eval solu grid elem 101 iy 1 gradient
fem export elem;dpotexdebug as test field reg 2 class 2 iy 2
fem export elem;dpoteydebug as test field reg 2 class 2 iy 3
fem export elem;dpotezdebug as test field reg 2 class 2 iy 4

fem eval solu grid elem 101 iy 1 gradient opti
fem export elem;dpotex as test field reg 2 class 2 iy 2
fem export elem;dpotey as test field reg 2 class 2 iy 3
fem export elem;dpotez as test field reg 2 class 2 iy 4

fem export node;geom as test reg 2
fem export elem;geom as test reg 2

sub WriteGradPhiExelem {

 ( $DXFILENAME, $DYFILENAME, $DZFILENAME, $OUTPUTNAME ) = @_;

  my $Found = 0;
  my $Found2 = 0;
  my $First = 1;
  my $InputLine = ' ';

  CORE::open( OUTPUTFILE,">$OUTPUTNAME" ) or die( "ERROR: Unable to open output file\n" );
  CORE::open( INPUTFILE,"<$DXFILENAME" ) or die( "ERROR: Unable to open DX input file\n" );

  while( <INPUTFILE> ) {
		if( /Nodes:/ ) {
			$Inputline = $_;

			$Found2 = 0;
      CORE::open( INPUTFILE2,"<$DYFILENAME" ) or die( "ERROR: Unable to open DY input file\n" );
			while( <INPUTFILE2> ) {
				if( /Nodes:/ ) {
					$Found2 = 0;
				}
				if( $Found2 ) {
					print( OUTPUTFILE "$_" );
				}
				if( /Values:/ ) {
					$Found2 = 1;
				}
			}
			CORE::close( INPUTFILE2 );

			$Found2 = 0;
      CORE::open( INPUTFILE2,"<$DZFILENAME" ) or die( "ERROR: Unable to open DZ input file\n" );
			while( <INPUTFILE2> ) {
				if( /Nodes:/ ) {
					$Found2 = 0;
				}
				if( $Found2 ) {
					print( OUTPUTFILE "$_" );
				}
				if( /Values:/ ) {
					$Found2 = 1;
				}
			}
			CORE::close( INPUTFILE2 );

			print( OUTPUTFILE "$Inputline" );
		}
		if( !$Found ) {
			print( OUTPUTFILE $_ );
		} elsif( $First ) {
      print( OUTPUTFILE ' 1) gradphi, field, rectangular cartesian, #Components=3'."\n");
      print( OUTPUTFILE '   x.  l.Lagrange*l.Lagrange*l.Lagrange, no modify, grid based.'."\n");
			$First = 0;
		} 
		if( /Fields/ ) {
			$Found = 1;
		}
		if( /xi1/ ) {
			print( OUTPUTFILE $_ );
      print( OUTPUTFILE '   y.  l.Lagrange*l.Lagrange*l.Lagrange, no modify, grid based.'."\n");
	  	print( OUTPUTFILE $_ );
      print( OUTPUTFILE '   z.  l.Lagrange*l.Lagrange*l.Lagrange, no modify, grid based.'."\n");
			print( OUTPUTFILE $_ );
		}
		if(( /Element/ ) && $Found ) {
			print( OUTPUTFILE $_ );
			$Found = 0;	
    }
	}
  CORE::close( INPUTFILE );
  CORE::close( OUTPUTFILE );
  
} # WriteGradPhiExelem

$DXFILENAME = "dpotex.exelem";
$DYFILENAME = "dpotey.exelem";
$DZFILENAME = "dpotez.exelem";
$OUTPUTNAME = "GradPhi.exelem";

&WriteGradPhiExelem( $DXFILENAME, $DYFILENAME, $DZFILENAME, $OUTPUTNAME );
