fem define parameter;r;artery_vein;example      # Declares array dimensions
fem reallocate;
fem define coordinate;r;artery_vein;example     # Defines the coordinate system
fem define node;r;artery_vein;example           # Reads in nodal information
fem define base;r;artery_vein;example           # Defines basis function (02 funcns : 1. 1D cubic hermite 2. 1D linear)
fem define element;r;artery_vein;example        # Reads in element information
fem define field;r;artery_vein;example          # Reads in fields. Only first field (unstressed radius at nodes) is necessary for this problem
fem define element;r;artery_vein;example field  # Defines interpolation of field variables (linear)
fem define grid;r;artery_vein;example coronary  # Defines grid points with coronary option to discretise the spatial computational domain.
                                                # Also used the equal arc-length spacing 
fem update grid geometry;
fem define equation;r;artery_vein;example       # Defines equations                          
fem define material;r;artery_vein;example       # Reads in physical & mechanical properties
fem update material field material 4 no_field 1;
#                                               # Updates unstressed radius (mat 4) from field 1
fem define time;r;artery_vein;example           # Define boundary conditions. Step increase in press. at inlet. Constant press. at outlet
fem define initial;r;artery_vein;example        # Defines initial conditions
fem define solve;r;artery_vein;example          # Defines solution parameters

$time_initial=0.000;                            # Sets the initial time
$time_final=0.100;                              # Sets the final time
$time_step=0.0001;                              # Sets the time step time
$write_out_period=0.010;                        # Sets the results write out period
$eps=0.000001;

fem export points;$time_initial grid as vessel offset 0 pressure velocity radius;         
fem export grid;vessel as vessel offset_node 0 offset_elem 0 pressure velocity radius; 

# Results output loop

for ($time=$time_initial;$time<$time_final-$eps;$time=$time+$write_out_period)       
{                                                                           
fem solve restart to $write_out_period delta_t $time_step;
fem export points;$time+$write_out_period grid as vessel offset 0 pressure velocity radius;           
}                                                                           

