$h=440;
$w=300;

gfx read node 0;
gfx read element vessel;

gfx create window 1;
gfx modify window 1 layout width $w height $h;
gfx modify window 1 view eye_point 80.9676 -69.7192 -57.4544;
gfx modify window 1 view interest_point 20.6929 5.13519 6.44978;
gfx modify window 1 view up_vector -0.812555 -0.181379 -0.553946;
gfx modify window 1 view view_angle 23.7818;

#gfx create spectrum velocity linear reverse extend_below extend_above rainbow; 
#gfx modify spectrum velocity minimum 0.0;
#gfx modify spectrum velocity maximum 120.0;

gfx create spectrum pressure linear reverse extend_below extend_above rainbow; 
gfx modify spectrum pressure minimum 12.5;
gfx modify spectrum pressure maximum 14.0;


gfx modify g_element vessel cylinders radius_scalar radius scale_factor 1.0 select_on material default data pressure spectrum pressure selected_material default_selected;

gfx modify g_element vessel general circle_discretization 16;
gfx modify g_element vessel lines select_on invisible material default selected_material default_selected;

gfx modify window 1 set antialias 8;

# -------------------------- Creating still images --------------------------

$time_initial=0.00;
$time_final=0.10;
$write_out_period=0.01;
$eps=0.0001;
$image=0;

for ($time=$time_initial;$time<$time_final+$eps;$time=$time+$write_out_period)  
{
gfx read node $time; 
if ($image<10)
{
gfx print file 00${image}.jpg height $h width $w;
}
elsif (($image>9) && ($image<100))
{
gfx print file 0${image}.jpg height $h width $w;
}
else
{
gfx print file ${image}.jpg height $h width $w;
}
$image=$image+1;                      
}                                                                           

# ------------------------------ Making Movie -------------------------------

$image='000.jpg';

for ($a=1;$a<=int(($time_final-$time_initial+$eps)/$write_out_period);$a=$a+1)
{
if ($a<10)
{
$image=$image.' '.'00'.${a}.'.jpg';
} 
elsif (($a>9) && ($a<100))
{
$image=$image.' '.'0'.${a}.'.jpg';
} 
else
{
$image=$image.' '.${a}.'.jpg';
} 
}

system "makemovie -o flow.mov -f qt -c jpeg $image";

