
$OPTIM_MAGN=0;
$OPTIM_POTL=1;
$OPTIM_BOTH=0;

$TSTART="1.0";
$TEND="3.1";
$TSTEP=1;
# only works for 1 because of CALC_SAMPLE_FROM_TIME/GETDIPOLE 
# differences in UPOPTI/MAGSOL
$FREQ=1;


$EXPORT=1;
$DIPOLE=1;

$OUT="output";
$FORMAT="binary";

$MAGOFFSET=20000;
$POTOFFSET=30000;

if(!defined $example) 
{  
    $example='.' ;
    $OUT="output";
} else{
    $OUT=".";
}

fem def para;r;$example/torso_dipole
fem def coor 3,1;
fem def base;r;$example/bicubic_bilinear;

fem def node;r;$example/skin;
fem def elem;r;$example/skin_lin;


if($EXPORT)
{
    fem export node;$OUT/torso as torso;
    fem export elem;$OUT/skin  as skin;
}


#
# Group nodes
#
fem group node 29      as FIXEDNODE;
fem group node 1,290   as SURFENDS;
fem group node 2..289  as SURFNORM;
$COMPNODES="1..290"

fem def equa;r;$example/laplace_nr1 reg all;
fem def mate;r;$example/mate_nr1    reg all;
fem def init;r;$example/noflux_nr1  reg all;
fem def sour;r;$example/dipole_guess reg $DIPOLE;
fem def solv;r;$example/static_nr1 reg all;


#
# Data points
#
#
# Electrodes
#
fem def data;r;$example/electrodes_mag field num_field 3;
fem exp data;$OUT/electrodes_mag as electrodes_mag offset $MAGOFFSET;
fem def xi;c close;


#
# Read in recorded/known solutions
#
fem read matr;$example/mfi nss 1      # magnetic fields at sensors
fem read matr;$example/phi             # potential fields at electrodes

