set Num_threads 1
# Set up a regions for the torso
$torso = 1;

# Set up a class for the laplace problem
$laplace = 1;

# Read in geometry of the torso
fem define para;r;$example/torso
fem de coor 3,1
fem define nodes;r;$example/skin
fem de base;r;$example/torso
fem define ele;r;$example/skin

# Group nodes to be applied for the .ipinit
fem group node 1009 as bottom reg $torso
fem group node 1262 as top reg $torso
fem group node 1010..1261,1263..1298 as middle reg $torso

# Define the laplace problem in the torso
fem define eq;r;$example/skin reg $torso class $laplace
fem define mate;r;$example/skin reg $torso class $laplace 
fem define ini;r;$example/skin reg $torso class $laplace 
fem define solve;r;$example/skin reg $torso class $laplace   

# Perform an initial solve
fem solve reg $torso class $laplace

# Magnetic field at 19 electrodes recording place for SQUID
fem def data;r;$example/squid_19 field num_fields 3 reg $torso

# Read in the dipole source and multiply -1 to correct the dipole direction
fem define sour;r;$example/dipoles_elem reg $torso scale -1

# Change the location of the dipole
fem change source translate by 0,0,0
fem de sour;w;dipole_changed as dipole 
fem export sour;dipole_changed as dipole


for $M (0..5)
{
$time=$M
# Apply the sources to the laplace problem
fem update sour reg $torso class $laplace time $time

# Solve the laplace problem
fem solve reg $torso class $laplace
fem export node;torso_pot_$time reg $torso class $laplace field as torso

# eval solu magnetic [data/mfi]
# both-primary/secondary
# squid-config 3- Z vectors @ 19 positions
fem eval solu mag from data both squid_config 3 time $time
fem export data;torso_mag_$time as torso_mag field_num 1..3 field_name mag
}
