#Example_141: Reads all ipfiles for Auckland's
#full anatomical model of the ventricles (geometry fibres and sheets). 
#Exports of node and element files to cmgui.

fem
fem define para;r;para
fem define coord;r;heart   #3D Prolate spheroidal coordinates
fem define base;r;heart          
#fem define node;r;heart         
#fem define element;r;heart      




#
# Convert nodes to RC
#
fem define node;r;heart_3lin       
fem define element;r;heart_3herm     
fem change coor
fem define node;w;heart_rc
fem export nodes;heart as heart
fem export elem;heart as heart
system "change_node_positions.pl heart_rc.ipnode heart_rc_kat.ipnode heart_rc_new.ipnode"
fem quit



#fem define fibre;r;heart         
#fem define element;r;heart fibre 

fem export nodes as heart                 #export nodes to cmgui
fem export elements as heart              #export elements to cmgui




fem group elements 1..30 as epi
fem group elements 31..60 as lv_endo
fem group elements 1..2,9..12,19..20 as rv_epi
fem group elements 31..32,39..42,49..50 as rv_sept 


#
# Evaluate surface geometry and create data files
#
#fem evaluate field;epi geometry element epi xi 0.05,0.05,1
#system "opfiel2ipdata.pl epi.opfiel epi.ipdata x x 1.00"

#fem evaluate field;lv_endo geometry element lv_endo xi 0.05,0.05,1
#system "opfiel2ipdata.pl lv_endo.opfiel lv_endo.ipdata x x 0.00"

#fem evaluate field;rv_endo geometry element rv_epi xi 0.05,0.05,1
#system "opfiel2ipdata.pl rv_endo.opfiel rv_endo.ipdata x x 0.00"

#fem evaluate field;rv_sept geometry element rv_sept xi 0.05,0.05,1
#system "opfiel2ipdata.pl rv_sept.opfiel rv_sept.ipdata x x 1.00"

#
# Export data for visualisation
#
#FEM define data;r;epi
#FEM export data;epi as epi_data offset 100000

#FEM define data;r;lv_endo 
#FEM export data;lv_endo as lv_endo_data offset 200000

#FEM define data;r;rv_endo 
#FEM export data;rv_endo as rv_endo_data offset 300000

#FEM define data;r;rv_sept 
#FEM export data;rv_sept as rv_sept_data offset 400000





FEM change coor
#fem def coor 3,1
fem export nodes;junk as junk
fem export elem;junk as junk


#fem quit


